_I2C1_Initialize:
;I2C.c,50 :: 		void I2C1_Initialize(void) {
;I2C.c,57 :: 		GPIOBEN_bit = 1;                  // Set GPIOB clock enable bit
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(GPIOBEN_bit+0)
MOVT	R0, #hi_addr(GPIOBEN_bit+0)
STR	R2, [R0, #0]
;I2C.c,59 :: 		GPIOB_MODER   |= 0x0000A000;      // Alternate function on bits 6 and 7
MOVW	R0, #lo_addr(GPIOB_MODER+0)
MOVT	R0, #hi_addr(GPIOB_MODER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #40960
MOVW	R0, #lo_addr(GPIOB_MODER+0)
MOVT	R0, #hi_addr(GPIOB_MODER+0)
STR	R1, [R0, #0]
;I2C.c,60 :: 		GPIOB_OTYPER  |= 0x000000C0;      // Output open-drain on bits 6 and 7
MOVW	R0, #lo_addr(GPIOB_OTYPER+0)
MOVT	R0, #hi_addr(GPIOB_OTYPER+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #192
MOVW	R0, #lo_addr(GPIOB_OTYPER+0)
MOVT	R0, #hi_addr(GPIOB_OTYPER+0)
STR	R1, [R0, #0]
;I2C.c,61 :: 		GPIOB_OSPEEDR |= 0x0000F000;      // Outpu high speed on bits 6 and 7
MOVW	R0, #lo_addr(GPIOB_OSPEEDR+0)
MOVT	R0, #hi_addr(GPIOB_OSPEEDR+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #61440
MOVW	R0, #lo_addr(GPIOB_OSPEEDR+0)
MOVT	R0, #hi_addr(GPIOB_OSPEEDR+0)
STR	R1, [R0, #0]
;I2C.c,62 :: 		GPIOB_PUPDR    = 0x00000000;      // No pull-up/pull-down on port B
MOVS	R1, #0
MOVW	R0, #lo_addr(GPIOB_PUPDR+0)
MOVT	R0, #hi_addr(GPIOB_PUPDR+0)
STR	R1, [R0, #0]
;I2C.c,63 :: 		GPIOB_AFRL    |= 0x44000000;      // Select alternate function I2C1 for bits 6 and 7
MOVW	R0, #lo_addr(GPIOB_AFRL+0)
MOVT	R0, #hi_addr(GPIOB_AFRL+0)
LDR	R0, [R0, #0]
ORR	R1, R0, #1140850688
MOVW	R0, #lo_addr(GPIOB_AFRL+0)
MOVT	R0, #hi_addr(GPIOB_AFRL+0)
STR	R1, [R0, #0]
;I2C.c,66 :: 		I2C1EN_bit = 1;                   // Enable I2C1 peripheral clock
MOVW	R0, #lo_addr(I2C1EN_bit+0)
MOVT	R0, #hi_addr(I2C1EN_bit+0)
STR	R2, [R0, #0]
;I2C.c,68 :: 		SWRST_I2C1_CR1_bit = 1;           // Execute software reset
MOVW	R0, #lo_addr(SWRST_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(SWRST_I2C1_CR1_bit+0)
STR	R2, [R0, #0]
;I2C.c,69 :: 		delay_ms(10);
MOVW	R7, #6782
MOVT	R7, #6
NOP
NOP
L_I2C1_Initialize0:
SUBS	R7, R7, #1
BNE	L_I2C1_Initialize0
NOP
NOP
NOP
;I2C.c,70 :: 		SWRST_I2C1_CR1_bit = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(SWRST_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(SWRST_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,72 :: 		I2C1_CR2 = 0x001E;                // Set peripheral clock register
MOVS	R1, #30
MOVW	R0, #lo_addr(I2C1_CR2+0)
MOVT	R0, #hi_addr(I2C1_CR2+0)
STR	R1, [R0, #0]
;I2C.c,73 :: 		I2C1_CCR = 0xC003;                // Configure clock control register
MOVW	R1, #49155
MOVW	R0, #lo_addr(I2C1_CCR+0)
MOVT	R0, #hi_addr(I2C1_CCR+0)
STR	R1, [R0, #0]
;I2C.c,74 :: 		I2C1_TRISE = 0x000A;              // Configure rise time register
MOVS	R1, #10
MOVW	R0, #lo_addr(I2C1_TRISE+0)
MOVT	R0, #hi_addr(I2C1_TRISE+0)
STR	R1, [R0, #0]
;I2C.c,75 :: 		PE_I2C1_CR1_bit = 1;              // Enable I2C1 module
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PE_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(PE_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,78 :: 		}
L_end_I2C1_Initialize:
BX	LR
; end of _I2C1_Initialize
_ReadRegs:
;I2C.c,87 :: 		void ReadRegs(char Addr, char Cnt, char *Bfr) {
; Bfr start address is: 8 (R2)
; Cnt start address is: 4 (R1)
; Addr start address is: 0 (R0)
; Bfr end address is: 8 (R2)
; Cnt end address is: 4 (R1)
; Addr end address is: 0 (R0)
; Addr start address is: 0 (R0)
; Cnt start address is: 4 (R1)
; Bfr start address is: 8 (R2)
;I2C.c,92 :: 		RdRegAddr = Addr;
MOVW	R3, #lo_addr(_RdRegAddr+0)
MOVT	R3, #hi_addr(_RdRegAddr+0)
STRB	R0, [R3, #0]
; Addr end address is: 0 (R0)
;I2C.c,93 :: 		RdByteCnt = Cnt;
MOVW	R3, #lo_addr(_RdByteCnt+0)
MOVT	R3, #hi_addr(_RdByteCnt+0)
STRB	R1, [R3, #0]
; Cnt end address is: 4 (R1)
;I2C.c,94 :: 		RdBufPtr = Bfr;
MOVW	R3, #lo_addr(_RdBufPtr+0)
MOVT	R3, #hi_addr(_RdBufPtr+0)
STR	R2, [R3, #0]
; Bfr end address is: 8 (R2)
;I2C.c,102 :: 		I2C1_State = 1;
MOVS	R4, #1
MOVW	R3, #lo_addr(_I2C1_State+0)
MOVT	R3, #hi_addr(_I2C1_State+0)
STRB	R4, [R3, #0]
;I2C.c,103 :: 		}
L_end_ReadRegs:
BX	LR
; end of _ReadRegs
_WriteRegs:
;I2C.c,112 :: 		void WriteRegs(char Addr, char Cnt, char *Bfr) {
; Bfr start address is: 8 (R2)
; Cnt start address is: 4 (R1)
; Addr start address is: 0 (R0)
; Bfr end address is: 8 (R2)
; Cnt end address is: 4 (R1)
; Addr end address is: 0 (R0)
; Addr start address is: 0 (R0)
; Cnt start address is: 4 (R1)
; Bfr start address is: 8 (R2)
;I2C.c,118 :: 		WrRegAddr = Addr;
MOVW	R3, #lo_addr(_WrRegAddr+0)
MOVT	R3, #hi_addr(_WrRegAddr+0)
STRB	R0, [R3, #0]
; Addr end address is: 0 (R0)
;I2C.c,119 :: 		WrByteCnt = Cnt;
MOVW	R3, #lo_addr(_WrByteCnt+0)
MOVT	R3, #hi_addr(_WrByteCnt+0)
STRB	R1, [R3, #0]
;I2C.c,120 :: 		WrBufPtr = Bfr;
MOVW	R3, #lo_addr(_WrBufPtr+0)
MOVT	R3, #hi_addr(_WrBufPtr+0)
STR	R2, [R3, #0]
;I2C.c,127 :: 		for (i=0;i<Cnt;i++)
; i start address is: 0 (R0)
MOVS	R0, #0
SXTH	R0, R0
; Cnt end address is: 4 (R1)
; i end address is: 0 (R0)
L_WriteRegs2:
; i start address is: 0 (R0)
; Bfr start address is: 8 (R2)
; Bfr end address is: 8 (R2)
; Cnt start address is: 4 (R1)
CMP	R0, R1
IT	GE
BGE	L_WriteRegs3
; Bfr end address is: 8 (R2)
;I2C.c,128 :: 		PrintBuf[i] = Bfr[i];
; Bfr start address is: 8 (R2)
MOVW	R3, #lo_addr(_PrintBuf+0)
MOVT	R3, #hi_addr(_PrintBuf+0)
ADDS	R4, R3, R0
ADDS	R3, R2, R0
LDRB	R3, [R3, #0]
STRB	R3, [R4, #0]
;I2C.c,127 :: 		for (i=0;i<Cnt;i++)
ADDS	R0, R0, #1
SXTH	R0, R0
;I2C.c,128 :: 		PrintBuf[i] = Bfr[i];
; Bfr end address is: 8 (R2)
; Cnt end address is: 4 (R1)
; i end address is: 0 (R0)
IT	AL
BAL	L_WriteRegs2
L_WriteRegs3:
;I2C.c,136 :: 		I2C1_State = 18;
MOVS	R4, #18
MOVW	R3, #lo_addr(_I2C1_State+0)
MOVT	R3, #hi_addr(_I2C1_State+0)
STRB	R4, [R3, #0]
;I2C.c,137 :: 		}
L_end_WriteRegs:
BX	LR
; end of _WriteRegs
_DisplayData:
;I2C.c,142 :: 		void DisplayData(char *Bfr, char Cnt) {
; Cnt start address is: 4 (R1)
; Bfr start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
MOV	R6, R0
UXTB	R7, R1
; Cnt end address is: 4 (R1)
; Bfr end address is: 0 (R0)
; Bfr start address is: 24 (R6)
; Cnt start address is: 28 (R7)
;I2C.c,148 :: 		memset(RdBuffer,0,BUFSIZ);
MOVS	R2, #32
SXTH	R2, R2
MOVS	R1, #0
MOVW	R0, #lo_addr(_RdBuffer+0)
MOVT	R0, #hi_addr(_RdBuffer+0)
BL	_memset+0
;I2C.c,149 :: 		if (Cnt > 8) {
CMP	R7, #8
IT	LS
BLS	L_DisplayData5
; Cnt end address is: 28 (R7)
;I2C.c,150 :: 		for (i=0;i<8;i++)
; i start address is: 0 (R0)
MOVS	R0, #0
SXTH	R0, R0
; Bfr end address is: 24 (R6)
; i end address is: 0 (R0)
MOV	R1, R6
L_DisplayData6:
; Bfr start address is: 4 (R1)
; i start address is: 0 (R0)
; Bfr start address is: 4 (R1)
; Bfr end address is: 4 (R1)
CMP	R0, #8
IT	GE
BGE	L_DisplayData7
; Bfr end address is: 4 (R1)
;I2C.c,151 :: 		RdBuffer[i] = Bfr[i];
; Bfr start address is: 4 (R1)
MOVW	R2, #lo_addr(_RdBuffer+0)
MOVT	R2, #hi_addr(_RdBuffer+0)
ADDS	R3, R2, R0
ADDS	R2, R1, R0
LDRB	R2, [R2, #0]
STRB	R2, [R3, #0]
;I2C.c,150 :: 		for (i=0;i<8;i++)
ADDS	R0, R0, #1
SXTH	R0, R0
;I2C.c,151 :: 		RdBuffer[i] = Bfr[i];
; i end address is: 0 (R0)
; Bfr end address is: 4 (R1)
IT	AL
BAL	L_DisplayData6
L_DisplayData7:
;I2C.c,152 :: 		} else {
IT	AL
BAL	L_DisplayData9
L_DisplayData5:
;I2C.c,153 :: 		for (i=0;i<Cnt;i++)
; i start address is: 16 (R4)
; Cnt start address is: 28 (R7)
; Bfr start address is: 24 (R6)
MOVS	R4, #0
SXTH	R4, R4
; Bfr end address is: 24 (R6)
; Cnt end address is: 28 (R7)
; i end address is: 16 (R4)
MOV	R1, R6
UXTB	R0, R7
L_DisplayData10:
; i start address is: 16 (R4)
; Bfr start address is: 4 (R1)
; Cnt start address is: 0 (R0)
; Bfr start address is: 4 (R1)
; Bfr end address is: 4 (R1)
CMP	R4, R0
IT	GE
BGE	L_DisplayData11
; Bfr end address is: 4 (R1)
;I2C.c,154 :: 		RdBuffer[i] = Bfr[i];
; Bfr start address is: 4 (R1)
MOVW	R2, #lo_addr(_RdBuffer+0)
MOVT	R2, #hi_addr(_RdBuffer+0)
ADDS	R3, R2, R4
ADDS	R2, R1, R4
LDRB	R2, [R2, #0]
STRB	R2, [R3, #0]
;I2C.c,153 :: 		for (i=0;i<Cnt;i++)
ADDS	R4, R4, #1
SXTH	R4, R4
;I2C.c,154 :: 		RdBuffer[i] = Bfr[i];
; Cnt end address is: 0 (R0)
; Bfr end address is: 4 (R1)
; i end address is: 16 (R4)
IT	AL
BAL	L_DisplayData10
L_DisplayData11:
;I2C.c,155 :: 		}
L_DisplayData9:
;I2C.c,169 :: 		}
L_end_DisplayData:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _DisplayData
_TimeoutCheck:
;I2C.c,174 :: 		void TimeoutCheck(unsigned TimeoutState) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
STRH	R0, [SP, #8]
;I2C.c,177 :: 		if (check_timer(I2C1Timer) == 0) {          // If timeout
MOVW	R1, #lo_addr(_I2C1Timer+0)
MOVT	R1, #hi_addr(_I2C1Timer+0)
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L_TimeoutCheck13
;I2C.c,179 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;I2C.c,180 :: 		sprintf(BufNum,"Timeout in state %d\r\n",TimeoutState);
MOVW	R3, #lo_addr(?lstr_1_I2C+0)
MOVT	R3, #hi_addr(?lstr_1_I2C+0)
MOV	R2, R0
LDRH	R1, [SP, #8]
PUSH	(R1)
PUSH	(R3)
PUSH	(R2)
BL	_sprintf+0
ADD	SP, SP, #12
;I2C.c,181 :: 		UART6_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_UART6_PutQueue+0
;I2C.c,182 :: 		free_timer(I2C1Timer);                  // Release Wi-Fi timer back to the pool
MOVW	R1, #lo_addr(_I2C1Timer+0)
MOVT	R1, #hi_addr(_I2C1Timer+0)
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_free_timer+0
;I2C.c,183 :: 		I2C1_State = 0;                         // Return to holding state
MOVS	R2, #0
MOVW	R1, #lo_addr(_I2C1_State+0)
MOVT	R1, #hi_addr(_I2C1_State+0)
STRB	R2, [R1, #0]
;I2C.c,184 :: 		}
L_TimeoutCheck13:
;I2C.c,185 :: 		}
L_end_TimeoutCheck:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _TimeoutCheck
_I2C1_SM:
;I2C.c,190 :: 		void I2C1_SM(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;I2C.c,197 :: 		switch (I2C1_State) {                       // Hold here until user changes state
IT	AL
BAL	L_I2C1_SM14
;I2C.c,198 :: 		case 0:
L_I2C1_SM16:
;I2C.c,199 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,208 :: 		case 1:
L_I2C1_SM17:
;I2C.c,209 :: 		I2C1Timer = get_timer();            // Get a timer handle
BL	_get_timer+0
MOVW	R1, #lo_addr(_I2C1Timer+0)
MOVT	R1, #hi_addr(_I2C1Timer+0)
STRB	R0, [R1, #0]
;I2C.c,210 :: 		set_timer(I2C1Timer,500);           // Set timer
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,211 :: 		I2C1_SR1 = 0x0000;
MOVS	R1, #0
MOVW	R0, #lo_addr(I2C1_SR1+0)
MOVT	R0, #hi_addr(I2C1_SR1+0)
STR	R1, [R0, #0]
;I2C.c,214 :: 		TempPtr = RdBufPtr;
MOVW	R0, #lo_addr(_RdBufPtr+0)
MOVT	R0, #hi_addr(_RdBufPtr+0)
LDR	R1, [R0, #0]
MOVW	R0, #lo_addr(I2C1_SM_TempPtr_L0+0)
MOVT	R0, #hi_addr(I2C1_SM_TempPtr_L0+0)
STR	R1, [R0, #0]
;I2C.c,215 :: 		TempCnt = RdByteCnt;
MOVW	R0, #lo_addr(_RdByteCnt+0)
MOVT	R0, #hi_addr(_RdByteCnt+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(I2C1_SM_TempCnt_L0+0)
MOVT	R0, #hi_addr(I2C1_SM_TempCnt_L0+0)
STRB	R1, [R0, #0]
;I2C.c,223 :: 		I2C1_State = 2;
MOVS	R1, #2
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,224 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,226 :: 		case 2:
L_I2C1_SM18:
;I2C.c,227 :: 		if (!BUSY_I2C1_SR2_bit) {           // Make sure bus is not busy
MOVW	R1, #lo_addr(BUSY_I2C1_SR2_bit+0)
MOVT	R1, #hi_addr(BUSY_I2C1_SR2_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_I2C1_SM19
;I2C.c,228 :: 		START_I2C1_CR1_bit = 1;         // Send Start bit
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(START_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(START_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,229 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,231 :: 		I2C1_State = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,232 :: 		}
L_I2C1_SM19:
;I2C.c,233 :: 		TimeoutCheck(2);
MOVS	R0, #2
BL	_TimeoutCheck+0
;I2C.c,234 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,236 :: 		case 3:
L_I2C1_SM20:
;I2C.c,237 :: 		if (SB_I2C1_SR1_bit) {              // When Start Flag is set
MOVW	R1, #lo_addr(SB_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(SB_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM21
;I2C.c,238 :: 		I2C1_DR = (STMPE610ADDR);       // Send slave address + write
MOVS	R1, #136
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
STR	R1, [R0, #0]
;I2C.c,239 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,241 :: 		I2C1_State = 4;
MOVS	R1, #4
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,242 :: 		}
L_I2C1_SM21:
;I2C.c,243 :: 		TimeoutCheck(3);
MOVS	R0, #3
BL	_TimeoutCheck+0
;I2C.c,244 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,246 :: 		case 4:
L_I2C1_SM22:
;I2C.c,247 :: 		if (ADDR_I2C1_SR1_bit) {            // Read SR1 waiting for ADDR bit
MOVW	R1, #lo_addr(ADDR_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(ADDR_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM23
;I2C.c,248 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,250 :: 		I2C1_State = 5;
MOVS	R1, #5
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,251 :: 		}
L_I2C1_SM23:
;I2C.c,252 :: 		TimeoutCheck(4);
MOVS	R0, #4
BL	_TimeoutCheck+0
;I2C.c,253 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,255 :: 		case 5:
L_I2C1_SM24:
;I2C.c,256 :: 		if (TRA_I2C1_SR2_bit) {             // Read SR2 - this will clear ADDR in SR1
MOVW	R1, #lo_addr(TRA_I2C1_SR2_bit+0)
MOVT	R1, #hi_addr(TRA_I2C1_SR2_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM25
;I2C.c,258 :: 		I2C1_State = 6;
MOVS	R1, #6
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,259 :: 		}
L_I2C1_SM25:
;I2C.c,260 :: 		TimeoutCheck(5);
MOVS	R0, #5
BL	_TimeoutCheck+0
;I2C.c,261 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,263 :: 		case 6:
L_I2C1_SM26:
;I2C.c,264 :: 		I2C1_DR = RdRegAddr;                // Send the register address that is to be read
MOVW	R0, #lo_addr(_RdRegAddr+0)
MOVT	R0, #hi_addr(_RdRegAddr+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
STR	R1, [R0, #0]
;I2C.c,265 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,267 :: 		I2C1_State = 7;
MOVS	R1, #7
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,268 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,270 :: 		case 7:
L_I2C1_SM27:
;I2C.c,271 :: 		if (TxE_I2C1_SR1_bit) {             // Wait for transmitter empty bit
MOVW	R1, #lo_addr(TxE_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(TxE_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM28
;I2C.c,273 :: 		I2C1_State = 8;
MOVS	R1, #8
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,274 :: 		}
L_I2C1_SM28:
;I2C.c,275 :: 		TimeoutCheck(7);
MOVS	R0, #7
BL	_TimeoutCheck+0
;I2C.c,276 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,278 :: 		case 8:
L_I2C1_SM29:
;I2C.c,279 :: 		START_I2C1_CR1_bit = 1;             // Set ReStart bit
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(START_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(START_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,280 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,282 :: 		I2C1_State = 9;
MOVS	R1, #9
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,283 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,285 :: 		case 9:
L_I2C1_SM30:
;I2C.c,286 :: 		if (SB_I2C1_SR1_bit) {              // When Start Flag is set
MOVW	R1, #lo_addr(SB_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(SB_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM31
;I2C.c,287 :: 		I2C1_DR = (STMPE610ADDR|0x01);  // Send slave address + read
MOVS	R1, #137
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
STR	R1, [R0, #0]
;I2C.c,288 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,290 :: 		I2C1_State = 10;
MOVS	R1, #10
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,291 :: 		}
L_I2C1_SM31:
;I2C.c,292 :: 		TimeoutCheck(9);
MOVS	R0, #9
BL	_TimeoutCheck+0
;I2C.c,293 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,295 :: 		case 10:
L_I2C1_SM32:
;I2C.c,296 :: 		if (ADDR_I2C1_SR1_bit) {            // Read SR1 waiting for ADDR bit
MOVW	R1, #lo_addr(ADDR_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(ADDR_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM33
;I2C.c,297 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,299 :: 		I2C1_State = 11;
MOVS	R1, #11
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,300 :: 		}
L_I2C1_SM33:
;I2C.c,301 :: 		TimeoutCheck(10);
MOVS	R0, #10
BL	_TimeoutCheck+0
;I2C.c,302 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,304 :: 		case 11:
L_I2C1_SM34:
;I2C.c,305 :: 		if (!TRA_I2C1_SR2_bit) {            // Read SR2 - this will clear ADDR in SR1
MOVW	R1, #lo_addr(TRA_I2C1_SR2_bit+0)
MOVT	R1, #hi_addr(TRA_I2C1_SR2_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_I2C1_SM35
;I2C.c,308 :: 		RdBufPtr++;                     // Reserve buffer position 0 for valid flag
MOVW	R1, #lo_addr(_RdBufPtr+0)
MOVT	R1, #hi_addr(_RdBufPtr+0)
LDR	R0, [R1, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
;I2C.c,311 :: 		if (RdByteCnt > 1) {
MOVW	R0, #lo_addr(_RdByteCnt+0)
MOVT	R0, #hi_addr(_RdByteCnt+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	LS
BLS	L_I2C1_SM36
;I2C.c,313 :: 		I2C1_State = 12;            // More than 1 byte to read
MOVS	R1, #12
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,314 :: 		} else {
IT	AL
BAL	L_I2C1_SM37
L_I2C1_SM36:
;I2C.c,316 :: 		I2C1_State = 15;            // Only 1 byte to read
MOVS	R1, #15
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,317 :: 		}
L_I2C1_SM37:
;I2C.c,318 :: 		}
L_I2C1_SM35:
;I2C.c,319 :: 		TimeoutCheck(11);
MOVS	R0, #11
BL	_TimeoutCheck+0
;I2C.c,320 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,322 :: 		case 12:
L_I2C1_SM38:
;I2C.c,323 :: 		ACK_I2C1_CR1_bit = 1;               // Set ACK bit
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(ACK_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(ACK_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,324 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,326 :: 		I2C1_State = 13;
MOVS	R1, #13
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,328 :: 		case 13:
L_I2C1_SM39:
;I2C.c,329 :: 		if (RxNE_I2C1_SR1_bit) {            // Wait for data
MOVW	R1, #lo_addr(RxNE_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(RxNE_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM40
;I2C.c,330 :: 		*RdBufPtr++ = I2C1_DR;          // Read a byte of data and put in buffer
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(_RdBufPtr+0)
MOVT	R1, #hi_addr(_RdBufPtr+0)
LDR	R0, [R1, #0]
STRB	R2, [R0, #0]
MOV	R0, R1
LDR	R0, [R0, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
;I2C.c,331 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,333 :: 		I2C1_State = 14;
MOVS	R1, #14
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,334 :: 		}
L_I2C1_SM40:
;I2C.c,335 :: 		TimeoutCheck(13);
MOVS	R0, #13
BL	_TimeoutCheck+0
;I2C.c,336 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,338 :: 		case 14:
L_I2C1_SM41:
;I2C.c,339 :: 		RdRegAddr++;                        // Diagnostic only
MOVW	R1, #lo_addr(_RdRegAddr+0)
MOVT	R1, #hi_addr(_RdRegAddr+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
STRB	R0, [R1, #0]
;I2C.c,340 :: 		RdByteCnt--;                        // Decrement read count
MOVW	R1, #lo_addr(_RdByteCnt+0)
MOVT	R1, #hi_addr(_RdByteCnt+0)
LDRB	R0, [R1, #0]
SUBS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R1, #0]
;I2C.c,341 :: 		if (RdByteCnt > 1) {
CMP	R0, #1
IT	LS
BLS	L_I2C1_SM42
;I2C.c,342 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,344 :: 		I2C1_State = 13;                // Back up one state
MOVS	R1, #13
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,345 :: 		} else {
IT	AL
BAL	L_I2C1_SM43
L_I2C1_SM42:
;I2C.c,347 :: 		I2C1_State = 15;                // Set up for last byte
MOVS	R1, #15
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,348 :: 		}
L_I2C1_SM43:
;I2C.c,349 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,351 :: 		case 15:
L_I2C1_SM44:
;I2C.c,352 :: 		ACK_I2C1_CR1_bit = 0;               // Clear ACK bit
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(ACK_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(ACK_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,353 :: 		STOP_I2C1_CR1_bit = 1;              // Set STOP bit
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(STOP_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(STOP_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,354 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,356 :: 		I2C1_State = 16;
MOVS	R1, #16
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,357 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,360 :: 		case 16:
L_I2C1_SM45:
;I2C.c,361 :: 		if (RxNE_I2C1_SR1_bit) {            // Wait for data
MOVW	R1, #lo_addr(RxNE_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(RxNE_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM46
;I2C.c,362 :: 		*RdBufPtr++ = I2C1_DR;          // Read last byte of data and put in buffer
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
LDR	R2, [R0, #0]
MOVW	R1, #lo_addr(_RdBufPtr+0)
MOVT	R1, #hi_addr(_RdBufPtr+0)
LDR	R0, [R1, #0]
STRB	R2, [R0, #0]
MOV	R0, R1
LDR	R0, [R0, #0]
ADDS	R0, R0, #1
STR	R0, [R1, #0]
;I2C.c,364 :: 		I2C1_State = 17;
MOVS	R1, #17
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,365 :: 		}
L_I2C1_SM46:
;I2C.c,366 :: 		TimeoutCheck(16);
MOVS	R0, #16
BL	_TimeoutCheck+0
;I2C.c,367 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,369 :: 		case 17:
L_I2C1_SM47:
;I2C.c,370 :: 		STOP_I2C1_CR1_bit = 0;              // Clear STOP bit
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(STOP_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(STOP_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,371 :: 		free_timer(I2C1Timer);              // Return I2C1 timer to pool
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;I2C.c,373 :: 		TempPtr[0] = 0xFF;                  // Set buffer valid flag
MOVS	R1, #255
MOVW	R2, #lo_addr(I2C1_SM_TempPtr_L0+0)
MOVT	R2, #hi_addr(I2C1_SM_TempPtr_L0+0)
LDR	R0, [R2, #0]
STRB	R1, [R0, #0]
;I2C.c,375 :: 		I2C1_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,378 :: 		DisplayData(TempPtr,TempCnt);
MOVW	R0, #lo_addr(I2C1_SM_TempCnt_L0+0)
MOVT	R0, #hi_addr(I2C1_SM_TempCnt_L0+0)
LDRB	R1, [R0, #0]
MOV	R0, R2
LDR	R0, [R0, #0]
BL	_DisplayData+0
;I2C.c,380 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,389 :: 		case 18:
L_I2C1_SM48:
;I2C.c,390 :: 		I2C1Timer = get_timer();            // Get a timer handle
BL	_get_timer+0
MOVW	R1, #lo_addr(_I2C1Timer+0)
MOVT	R1, #hi_addr(_I2C1Timer+0)
STRB	R0, [R1, #0]
;I2C.c,391 :: 		set_timer(I2C1Timer,5000);          // Set timer
MOVW	R1, #5000
BL	_set_timer+0
;I2C.c,401 :: 		I2C1_SR1 = 0x0000;
MOVS	R1, #0
MOVW	R0, #lo_addr(I2C1_SR1+0)
MOVT	R0, #hi_addr(I2C1_SR1+0)
STR	R1, [R0, #0]
;I2C.c,403 :: 		I2C1_State = 19;
MOVS	R1, #19
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,404 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,406 :: 		case 19:
L_I2C1_SM49:
;I2C.c,407 :: 		if (!BUSY_I2C1_SR2_bit) {           // Make sure bus is not busy
MOVW	R1, #lo_addr(BUSY_I2C1_SR2_bit+0)
MOVT	R1, #hi_addr(BUSY_I2C1_SR2_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_I2C1_SM50
;I2C.c,408 :: 		START_I2C1_CR1_bit = 1;         // Send Start bit
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(START_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(START_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,409 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,411 :: 		I2C1_State = 20;
MOVS	R1, #20
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,412 :: 		}
L_I2C1_SM50:
;I2C.c,413 :: 		TimeoutCheck(19);
MOVS	R0, #19
BL	_TimeoutCheck+0
;I2C.c,414 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,416 :: 		case 20:
L_I2C1_SM51:
;I2C.c,417 :: 		if (SB_I2C1_SR1_bit) {              // When Start Flag is set
MOVW	R1, #lo_addr(SB_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(SB_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM52
;I2C.c,418 :: 		I2C1_DR = (STMPE610ADDR);       // Send slave address + write
MOVS	R1, #136
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
STR	R1, [R0, #0]
;I2C.c,419 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,421 :: 		I2C1_State = 21;
MOVS	R1, #21
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,422 :: 		}
L_I2C1_SM52:
;I2C.c,423 :: 		TimeoutCheck(20);
MOVS	R0, #20
BL	_TimeoutCheck+0
;I2C.c,424 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,426 :: 		case 21:
L_I2C1_SM53:
;I2C.c,427 :: 		if (ADDR_I2C1_SR1_bit) {            // Read SR1 waiting for ADDR bit
MOVW	R1, #lo_addr(ADDR_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(ADDR_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM54
;I2C.c,428 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,430 :: 		I2C1_State = 22;
MOVS	R1, #22
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,431 :: 		}
L_I2C1_SM54:
;I2C.c,432 :: 		TimeoutCheck(21);
MOVS	R0, #21
BL	_TimeoutCheck+0
;I2C.c,433 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,435 :: 		case 22:
L_I2C1_SM55:
;I2C.c,436 :: 		if (TRA_I2C1_SR2_bit) {             // Read SR2 - this will clear ADDR in SR1
MOVW	R1, #lo_addr(TRA_I2C1_SR2_bit+0)
MOVT	R1, #hi_addr(TRA_I2C1_SR2_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM56
;I2C.c,437 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,439 :: 		I2C1_State = 23;
MOVS	R1, #23
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,440 :: 		}
L_I2C1_SM56:
;I2C.c,441 :: 		TimeoutCheck(22);
MOVS	R0, #22
BL	_TimeoutCheck+0
;I2C.c,442 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,444 :: 		case 23:
L_I2C1_SM57:
;I2C.c,445 :: 		if (TxE_I2C1_SR1_bit) {             // Wait for transmitter empty bit
MOVW	R1, #lo_addr(TxE_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(TxE_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM58
;I2C.c,452 :: 		I2C1_DR = WrRegAddr;            // Send the register address that is to be written
MOVW	R0, #lo_addr(_WrRegAddr+0)
MOVT	R0, #hi_addr(_WrRegAddr+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
STR	R1, [R0, #0]
;I2C.c,453 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,455 :: 		I2C1_State = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,456 :: 		}
L_I2C1_SM58:
;I2C.c,457 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,459 :: 		case 24:
L_I2C1_SM59:
;I2C.c,460 :: 		if (TxE_I2C1_SR1_bit) {             // Wait for transmitter empty bit
MOVW	R1, #lo_addr(TxE_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(TxE_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM60
;I2C.c,461 :: 		if (WrByteCnt > 1) {
MOVW	R0, #lo_addr(_WrByteCnt+0)
MOVT	R0, #hi_addr(_WrByteCnt+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	LS
BLS	L_I2C1_SM61
;I2C.c,462 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,464 :: 		I2C1_State = 25;            // More than 1 byte to write
MOVS	R1, #25
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,465 :: 		} else {
IT	AL
BAL	L_I2C1_SM62
L_I2C1_SM61:
;I2C.c,467 :: 		I2C1_State = 26;            // only 1 byte to write
MOVS	R1, #26
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,468 :: 		}
L_I2C1_SM62:
;I2C.c,469 :: 		}
L_I2C1_SM60:
;I2C.c,470 :: 		TimeoutCheck(24);
MOVS	R0, #24
BL	_TimeoutCheck+0
;I2C.c,471 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,473 :: 		case 25:
L_I2C1_SM63:
;I2C.c,480 :: 		I2C1_DR = *WrBufPtr++;              // Put byte in data register
MOVW	R2, #lo_addr(_WrBufPtr+0)
MOVT	R2, #hi_addr(_WrBufPtr+0)
LDR	R0, [R2, #0]
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
STR	R1, [R0, #0]
MOV	R0, R2
LDR	R0, [R0, #0]
ADDS	R0, R0, #1
STR	R0, [R2, #0]
;I2C.c,481 :: 		WrRegAddr++;                        // Diagnostic only
MOVW	R1, #lo_addr(_WrRegAddr+0)
MOVT	R1, #hi_addr(_WrRegAddr+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
STRB	R0, [R1, #0]
;I2C.c,482 :: 		WrByteCnt--;                        // Decrement write byte count
MOVW	R1, #lo_addr(_WrByteCnt+0)
MOVT	R1, #hi_addr(_WrByteCnt+0)
LDRB	R0, [R1, #0]
SUBS	R0, R0, #1
STRB	R0, [R1, #0]
;I2C.c,483 :: 		I2C1_State = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,484 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,486 :: 		case 26:
L_I2C1_SM64:
;I2C.c,493 :: 		I2C1_DR = *WrBufPtr;                // Put last byte in data register
MOVW	R0, #lo_addr(_WrBufPtr+0)
MOVT	R0, #hi_addr(_WrBufPtr+0)
LDR	R0, [R0, #0]
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(I2C1_DR+0)
MOVT	R0, #hi_addr(I2C1_DR+0)
STR	R1, [R0, #0]
;I2C.c,494 :: 		set_timer(I2C1Timer,500);
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #500
BL	_set_timer+0
;I2C.c,496 :: 		I2C1_State = 27;
MOVS	R1, #27
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,497 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,499 :: 		case 27:
L_I2C1_SM65:
;I2C.c,500 :: 		if (TxE_I2C1_SR1_bit) {             // Wait for transmitter empty bit
MOVW	R1, #lo_addr(TxE_I2C1_SR1_bit+0)
MOVT	R1, #hi_addr(TxE_I2C1_SR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM66
;I2C.c,502 :: 		I2C1_State = 28;
MOVS	R1, #28
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,503 :: 		}
L_I2C1_SM66:
;I2C.c,504 :: 		TimeoutCheck(28);
MOVS	R0, #28
BL	_TimeoutCheck+0
;I2C.c,505 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,507 :: 		case 28:
L_I2C1_SM67:
;I2C.c,508 :: 		STOP_I2C1_CR1_bit = 1;              // Set STOP bit
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(STOP_I2C1_CR1_bit+0)
MOVT	R0, #hi_addr(STOP_I2C1_CR1_bit+0)
STR	R1, [R0, #0]
;I2C.c,510 :: 		I2C1_State = 29;
MOVS	R1, #29
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,511 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,513 :: 		case 29:
L_I2C1_SM68:
;I2C.c,514 :: 		free_timer(I2C1Timer);              // Return I2C1 timer to pool
MOVW	R0, #lo_addr(_I2C1Timer+0)
MOVT	R0, #hi_addr(_I2C1Timer+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;I2C.c,516 :: 		I2C1_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
STRB	R1, [R0, #0]
;I2C.c,517 :: 		break;
IT	AL
BAL	L_I2C1_SM15
;I2C.c,518 :: 		}
L_I2C1_SM14:
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_I2C1_SM16
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_I2C1_SM17
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_I2C1_SM18
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #3
IT	EQ
BEQ	L_I2C1_SM20
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #4
IT	EQ
BEQ	L_I2C1_SM22
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #5
IT	EQ
BEQ	L_I2C1_SM24
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #6
IT	EQ
BEQ	L_I2C1_SM26
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #7
IT	EQ
BEQ	L_I2C1_SM27
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #8
IT	EQ
BEQ	L_I2C1_SM29
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #9
IT	EQ
BEQ	L_I2C1_SM30
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #10
IT	EQ
BEQ	L_I2C1_SM32
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #11
IT	EQ
BEQ	L_I2C1_SM34
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #12
IT	EQ
BEQ	L_I2C1_SM38
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #13
IT	EQ
BEQ	L_I2C1_SM39
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #14
IT	EQ
BEQ	L_I2C1_SM41
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #15
IT	EQ
BEQ	L_I2C1_SM44
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #16
IT	EQ
BEQ	L_I2C1_SM45
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #17
IT	EQ
BEQ	L_I2C1_SM47
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #18
IT	EQ
BEQ	L_I2C1_SM48
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #19
IT	EQ
BEQ	L_I2C1_SM49
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #20
IT	EQ
BEQ	L_I2C1_SM51
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #21
IT	EQ
BEQ	L_I2C1_SM53
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #22
IT	EQ
BEQ	L_I2C1_SM55
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #23
IT	EQ
BEQ	L_I2C1_SM57
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #24
IT	EQ
BEQ	L_I2C1_SM59
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #25
IT	EQ
BEQ	L_I2C1_SM63
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #26
IT	EQ
BEQ	L_I2C1_SM64
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #27
IT	EQ
BEQ	L_I2C1_SM65
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #28
IT	EQ
BEQ	L_I2C1_SM67
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #29
IT	EQ
BEQ	L_I2C1_SM68
L_I2C1_SM15:
;I2C.c,519 :: 		}
L_end_I2C1_SM:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _I2C1_SM
