#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/i2c.h"
#line 15 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/i2c.h"
void I2C1_Initialize(void);
void ReadRegs(char Addr, char Cnt, char *Bfr);
void WriteRegs(char Addr, char Cnt, char *Bfr);
void DisplayData(char *Bfr, char Cnt);
void TimeoutCheck(unsigned TimeoutState);

void I2C1_SM(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
#line 17 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
char* GetCmdBuf(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
#line 11 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/rgb.h"
#line 13 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/rgb.h"
void RGB_Init(void);
void RGB_Set_Red(void);
void RGB_Clr_Red(void);
void RGB_Set_Green(void);
void RGB_Clr_Green(void);
void RGB_Set_Blue(void);
void RGB_Clr_Blue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
#line 19 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
#line 9 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/common.h"
#line 25 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
const code char STMPE610ADDR = 0x88;



char RdRegAddr = 0;
char RdByteCnt = 2;
char RdBuffer[ 32 ];
char *RdBufPtr;

char WrRegAddr = 0;
char WrByteCnt = 0;
char WrBuffer[ 32 ];
char *WrBufPtr;

unsigned short int I2C1Timer;
char I2C1_State = 0;

char PrintBuf[32];
#line 50 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
void I2C1_Initialize(void) {






 GPIOBEN_bit = 1;

 GPIOB_MODER |= 0x0000A000;
 GPIOB_OTYPER |= 0x000000C0;
 GPIOB_OSPEEDR |= 0x0000F000;
 GPIOB_PUPDR = 0x00000000;
 GPIOB_AFRL |= 0x44000000;


 I2C1EN_bit = 1;

 SWRST_I2C1_CR1_bit = 1;
 delay_ms(10);
 SWRST_I2C1_CR1_bit = 0;

 I2C1_CR2 = 0x001E;
 I2C1_CCR = 0xC003;
 I2C1_TRISE = 0x000A;
 PE_I2C1_CR1_bit = 1;

  {} ;
}
#line 87 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
void ReadRegs(char Addr, char Cnt, char *Bfr) {
#line 92 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 RdRegAddr = Addr;
 RdByteCnt = Cnt;
 RdBufPtr = Bfr;
#line 101 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
  {} ;
 I2C1_State = 1;
}
#line 112 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
void WriteRegs(char Addr, char Cnt, char *Bfr) {
 int i;
#line 118 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 WrRegAddr = Addr;
 WrByteCnt = Cnt;
 WrBufPtr = Bfr;
#line 127 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 for (i=0;i<Cnt;i++)
 PrintBuf[i] = Bfr[i];
#line 135 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
  {} ;
 I2C1_State = 18;
}
#line 142 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
void DisplayData(char *Bfr, char Cnt) {
 int i;
#line 148 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 memset(RdBuffer,0, 32 );
 if (Cnt > 8) {
 for (i=0;i<8;i++)
 RdBuffer[i] = Bfr[i];
 } else {
 for (i=0;i<Cnt;i++)
 RdBuffer[i] = Bfr[i];
 }
#line 169 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
}
#line 174 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
void TimeoutCheck(unsigned TimeoutState) {
 char *BufNum;

 if (check_timer(I2C1Timer) == 0) {

 BufNum = GetBuffer();
 sprintf(BufNum,"Timeout in state %d\r\n",TimeoutState);
 UART6_PutQueue(BufNum);
 free_timer(I2C1Timer);
 I2C1_State = 0;
 }
}
#line 190 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
void I2C1_SM(void) {
 static char *TempPtr, TempCnt;
#line 197 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 switch (I2C1_State) {
 case 0:
 break;
#line 208 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 case 1:
 I2C1Timer = get_timer();
 set_timer(I2C1Timer,500);
 I2C1_SR1 = 0x0000;


 TempPtr = RdBufPtr;
 TempCnt = RdByteCnt;
#line 222 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
  {} ;
 I2C1_State = 2;
 break;

 case 2:
 if (!BUSY_I2C1_SR2_bit) {
 START_I2C1_CR1_bit = 1;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 3;
 }
 TimeoutCheck(2);
 break;

 case 3:
 if (SB_I2C1_SR1_bit) {
 I2C1_DR = (STMPE610ADDR);
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 4;
 }
 TimeoutCheck(3);
 break;

 case 4:
 if (ADDR_I2C1_SR1_bit) {
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 5;
 }
 TimeoutCheck(4);
 break;

 case 5:
 if (TRA_I2C1_SR2_bit) {
  {} ;
 I2C1_State = 6;
 }
 TimeoutCheck(5);
 break;

 case 6:
 I2C1_DR = RdRegAddr;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 7;
 break;

 case 7:
 if (TxE_I2C1_SR1_bit) {
  {} ;
 I2C1_State = 8;
 }
 TimeoutCheck(7);
 break;

 case 8:
 START_I2C1_CR1_bit = 1;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 9;
 break;

 case 9:
 if (SB_I2C1_SR1_bit) {
 I2C1_DR = (STMPE610ADDR|0x01);
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 10;
 }
 TimeoutCheck(9);
 break;

 case 10:
 if (ADDR_I2C1_SR1_bit) {
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 11;
 }
 TimeoutCheck(10);
 break;

 case 11:
 if (!TRA_I2C1_SR2_bit) {


 RdBufPtr++;


 if (RdByteCnt > 1) {
  {} ;
 I2C1_State = 12;
 } else {
  {} ;
 I2C1_State = 15;
 }
 }
 TimeoutCheck(11);
 break;

 case 12:
 ACK_I2C1_CR1_bit = 1;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 13;

 case 13:
 if (RxNE_I2C1_SR1_bit) {
 *RdBufPtr++ = I2C1_DR;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 14;
 }
 TimeoutCheck(13);
 break;

 case 14:
 RdRegAddr++;
 RdByteCnt--;
 if (RdByteCnt > 1) {
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 13;
 } else {
  {} ;
 I2C1_State = 15;
 }
 break;

 case 15:
 ACK_I2C1_CR1_bit = 0;
 STOP_I2C1_CR1_bit = 1;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 16;
 break;


 case 16:
 if (RxNE_I2C1_SR1_bit) {
 *RdBufPtr++ = I2C1_DR;
  {} ;
 I2C1_State = 17;
 }
 TimeoutCheck(16);
 break;

 case 17:
 STOP_I2C1_CR1_bit = 0;
 free_timer(I2C1Timer);

 TempPtr[0] = 0xFF;
  {} ;
 I2C1_State = 0;


 DisplayData(TempPtr,TempCnt);

 break;
#line 389 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 case 18:
 I2C1Timer = get_timer();
 set_timer(I2C1Timer,5000);
#line 401 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 I2C1_SR1 = 0x0000;
  {} ;
 I2C1_State = 19;
 break;

 case 19:
 if (!BUSY_I2C1_SR2_bit) {
 START_I2C1_CR1_bit = 1;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 20;
 }
 TimeoutCheck(19);
 break;

 case 20:
 if (SB_I2C1_SR1_bit) {
 I2C1_DR = (STMPE610ADDR);
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 21;
 }
 TimeoutCheck(20);
 break;

 case 21:
 if (ADDR_I2C1_SR1_bit) {
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 22;
 }
 TimeoutCheck(21);
 break;

 case 22:
 if (TRA_I2C1_SR2_bit) {
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 23;
 }
 TimeoutCheck(22);
 break;

 case 23:
 if (TxE_I2C1_SR1_bit) {
#line 452 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 I2C1_DR = WrRegAddr;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 24;
 }
 break;

 case 24:
 if (TxE_I2C1_SR1_bit) {
 if (WrByteCnt > 1) {
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 25;
 } else {
  {} ;
 I2C1_State = 26;
 }
 }
 TimeoutCheck(24);
 break;

 case 25:
#line 480 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 I2C1_DR = *WrBufPtr++;
 WrRegAddr++;
 WrByteCnt--;
 I2C1_State = 24;
 break;

 case 26:
#line 493 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/I2C.c"
 I2C1_DR = *WrBufPtr;
 set_timer(I2C1Timer,500);
  {} ;
 I2C1_State = 27;
 break;

 case 27:
 if (TxE_I2C1_SR1_bit) {
  {} ;
 I2C1_State = 28;
 }
 TimeoutCheck(28);
 break;

 case 28:
 STOP_I2C1_CR1_bit = 1;
  {} ;
 I2C1_State = 29;
 break;

 case 29:
 free_timer(I2C1Timer);
  {} ;
 I2C1_State = 0;
 break;
 }
}
