/**************************************************************************************************
  I2C.h
  I2C1 driver.
**************************************************************************************************/
#ifndef I2C_H
#define I2C_H


// Defines
#define WR 0x01
#define RD 0x02
#define BUFSIZ 32

// Function Prototypes
void I2C1_Initialize(void);
void ReadRegs(char Addr, char Cnt, char *Bfr);
void WriteRegs(char Addr, char Cnt, char *Bfr);
void DisplayData(char *Bfr, char Cnt);
void TimeoutCheck(unsigned TimeoutState);

void I2C1_SM(void);




#endif