_ExternalInterrupt0:
;STMPE610.c,80 :: 		void ExternalInterrupt0() iv IVT_INT_EXTI0 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;STMPE610.c,82 :: 		NVIC_IntDisable(IVT_INT_EXTI0);   // Disable EXTI0 interrupt
MOVW	R0, #22
BL	_NVIC_IntDisable+0
;STMPE610.c,83 :: 		PR0_bit = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PR0_bit+0)
MOVT	R0, #hi_addr(PR0_bit+0)
STR	R1, [R0, #0]
;STMPE610.c,84 :: 		IntFlag = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_IntFlag+0)
MOVT	R0, #hi_addr(_IntFlag+0)
STRB	R1, [R0, #0]
;STMPE610.c,85 :: 		}
L_end_ExternalInterrupt0:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _ExternalInterrupt0
_ExtIntEnable:
;STMPE610.c,90 :: 		void ExtIntEnable(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;STMPE610.c,93 :: 		GPIO_Set_Pin_Mode(&GPIOA_BASE, _GPIO_PIN_0, _GPIO_CFG_MODE_INPUT | _GPIO_CFG_PULL_UP);
MOVS	R2, #130
MOVW	R1, #0
MOVW	R0, #lo_addr(GPIOA_BASE+0)
MOVT	R0, #hi_addr(GPIOA_BASE+0)
BL	_GPIO_Set_Pin_Mode+0
;STMPE610.c,95 :: 		MR0_bit = 1;                      // Unmask interrupt request from line 0
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(MR0_bit+0)
MOVT	R0, #hi_addr(MR0_bit+0)
STR	R2, [R0, #0]
;STMPE610.c,97 :: 		TR0_bit = 0;                      // Disable rising trigger
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TR0_bit+0)
MOVT	R0, #hi_addr(TR0_bit+0)
STR	R1, [R0, #0]
;STMPE610.c,99 :: 		TR0_EXTI_FTSR_bit = 1;            // Enable falling trigger
MOVW	R0, #lo_addr(TR0_EXTI_FTSR_bit+0)
MOVT	R0, #hi_addr(TR0_EXTI_FTSR_bit+0)
STR	R2, [R0, #0]
;STMPE610.c,101 :: 		SYSCFGEN_bit = 1;                 // Enable system configuration controller clock
MOVW	R0, #lo_addr(SYSCFGEN_bit+0)
MOVT	R0, #hi_addr(SYSCFGEN_bit+0)
STR	R2, [R0, #0]
;STMPE610.c,103 :: 		SYSCFG_EXTICR1 = 0x00000000;      // Connect PA0 to EXTI0
MOVS	R1, #0
MOVW	R0, #lo_addr(SYSCFG_EXTICR1+0)
MOVT	R0, #hi_addr(SYSCFG_EXTICR1+0)
STR	R1, [R0, #0]
;STMPE610.c,105 :: 		NVIC_IntEnable(IVT_INT_EXTI0);    // Enable EXTI0 interrupt
MOVW	R0, #22
BL	_NVIC_IntEnable+0
;STMPE610.c,106 :: 		}
L_end_ExtIntEnable:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _ExtIntEnable
_PutFifo:
;STMPE610.c,112 :: 		void PutFifo(char *Bfr, char Cmd, char Addr, char Cnt) {
; Cnt start address is: 12 (R3)
; Addr start address is: 8 (R2)
; Cmd start address is: 4 (R1)
; Bfr start address is: 0 (R0)
; Cnt end address is: 12 (R3)
; Addr end address is: 8 (R2)
; Cmd end address is: 4 (R1)
; Bfr end address is: 0 (R0)
; Bfr start address is: 0 (R0)
; Cmd start address is: 4 (R1)
; Addr start address is: 8 (R2)
; Cnt start address is: 12 (R3)
;STMPE610.c,120 :: 		CmdFifo[CmdFifoIn].Buff = Bfr;
MOVW	R6, #lo_addr(_CmdFifoIn+0)
MOVT	R6, #hi_addr(_CmdFifoIn+0)
LDRB	R4, [R6, #0]
LSLS	R5, R4, #3
MOVW	R4, #lo_addr(_CmdFifo+0)
MOVT	R4, #hi_addr(_CmdFifo+0)
ADDS	R4, R4, R5
STR	R0, [R4, #0]
; Bfr end address is: 0 (R0)
;STMPE610.c,121 :: 		CmdFifo[CmdFifoIn].CmdCode = Cmd;
MOV	R4, R6
LDRB	R4, [R4, #0]
LSLS	R5, R4, #3
MOVW	R4, #lo_addr(_CmdFifo+0)
MOVT	R4, #hi_addr(_CmdFifo+0)
ADDS	R4, R4, R5
ADDS	R4, R4, #4
STRB	R1, [R4, #0]
; Cmd end address is: 4 (R1)
;STMPE610.c,122 :: 		CmdFifo[CmdFifoIn].RegAd = Addr;
MOV	R4, R6
LDRB	R4, [R4, #0]
LSLS	R5, R4, #3
MOVW	R4, #lo_addr(_CmdFifo+0)
MOVT	R4, #hi_addr(_CmdFifo+0)
ADDS	R4, R4, R5
ADDS	R4, R4, #5
STRB	R2, [R4, #0]
; Addr end address is: 8 (R2)
;STMPE610.c,123 :: 		CmdFifo[CmdFifoIn].Count = Cnt;
MOV	R4, R6
LDRB	R4, [R4, #0]
LSLS	R5, R4, #3
MOVW	R4, #lo_addr(_CmdFifo+0)
MOVT	R4, #hi_addr(_CmdFifo+0)
ADDS	R4, R4, R5
ADDS	R4, R4, #6
STRB	R3, [R4, #0]
; Cnt end address is: 12 (R3)
;STMPE610.c,125 :: 		if (++CmdFifoIn > (CMDFIFOLEN - 1))
MOV	R4, R6
LDRB	R4, [R4, #0]
ADDS	R4, R4, #1
UXTB	R4, R4
STRB	R4, [R6, #0]
CMP	R4, #255
IT	LS
BLS	L_PutFifo0
;STMPE610.c,126 :: 		CmdFifoIn = 0;
MOVS	R5, #0
MOVW	R4, #lo_addr(_CmdFifoIn+0)
MOVT	R4, #hi_addr(_CmdFifoIn+0)
STRB	R5, [R4, #0]
L_PutFifo0:
;STMPE610.c,128 :: 		}
L_end_PutFifo:
BX	LR
; end of _PutFifo
_GetFifo:
;STMPE610.c,134 :: 		char GetFifo(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;STMPE610.c,138 :: 		if (I2C1_State == 0) {                 // Execute if I2C1 state machine is not busy
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_GetFifo1
;STMPE610.c,139 :: 		if (CmdFifoIn != CmdFifoOut) {     // Execute if a command is in the fifo
MOVW	R0, #lo_addr(_CmdFifoOut+0)
MOVT	R0, #hi_addr(_CmdFifoOut+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_CmdFifoIn+0)
MOVT	R0, #hi_addr(_CmdFifoIn+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_GetFifo2
;STMPE610.c,148 :: 		switch (CmdFifo[CmdFifoOut].CmdCode) {
MOVW	R0, #lo_addr(_CmdFifoOut+0)
MOVT	R0, #hi_addr(_CmdFifoOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #3
MOVW	R0, #lo_addr(_CmdFifo+0)
MOVT	R0, #hi_addr(_CmdFifo+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #4
STR	R0, [SP, #4]
IT	AL
BAL	L_GetFifo3
;STMPE610.c,150 :: 		case 1: // Writing
L_GetFifo5:
;STMPE610.c,151 :: 		for (i=0;i<CmdFifo[CmdFifoOut].Count;i++) // Transfer data to write buffer
; i start address is: 12 (R3)
MOVS	R3, #0
SXTH	R3, R3
; i end address is: 12 (R3)
L_GetFifo6:
; i start address is: 12 (R3)
MOVW	R0, #lo_addr(_CmdFifoOut+0)
MOVT	R0, #hi_addr(_CmdFifoOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #3
MOVW	R0, #lo_addr(_CmdFifo+0)
MOVT	R0, #hi_addr(_CmdFifo+0)
ADDS	R0, R0, R1
ADDS	R0, R0, #6
LDRB	R0, [R0, #0]
CMP	R3, R0
IT	GE
BGE	L_GetFifo7
;STMPE610.c,152 :: 		WrBuffer[i] = *(CmdFifo[CmdFifoOut].Buff+i);
MOVW	R0, #lo_addr(_WrBuffer+0)
MOVT	R0, #hi_addr(_WrBuffer+0)
ADDS	R2, R0, R3
MOVW	R0, #lo_addr(_CmdFifoOut+0)
MOVT	R0, #hi_addr(_CmdFifoOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #3
MOVW	R0, #lo_addr(_CmdFifo+0)
MOVT	R0, #hi_addr(_CmdFifo+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
ADDS	R0, R0, R3
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;STMPE610.c,151 :: 		for (i=0;i<CmdFifo[CmdFifoOut].Count;i++) // Transfer data to write buffer
ADDS	R3, R3, #1
SXTH	R3, R3
;STMPE610.c,152 :: 		WrBuffer[i] = *(CmdFifo[CmdFifoOut].Buff+i);
; i end address is: 12 (R3)
IT	AL
BAL	L_GetFifo6
L_GetFifo7:
;STMPE610.c,154 :: 		WriteRegs(CmdFifo[CmdFifoOut].RegAd,CmdFifo[CmdFifoOut].Count,CmdFifo[CmdFifoOut].Buff);
MOVW	R0, #lo_addr(_CmdFifoOut+0)
MOVT	R0, #hi_addr(_CmdFifoOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #3
MOVW	R0, #lo_addr(_CmdFifo+0)
MOVT	R0, #hi_addr(_CmdFifo+0)
ADDS	R3, R0, R1
LDR	R0, [R3, #0]
MOV	R2, R0
ADDS	R0, R3, #6
LDRB	R0, [R0, #0]
UXTB	R1, R0
ADDS	R0, R3, #5
LDRB	R0, [R0, #0]
BL	_WriteRegs+0
;STMPE610.c,162 :: 		break;
IT	AL
BAL	L_GetFifo4
;STMPE610.c,164 :: 		case 2: // Reading
L_GetFifo9:
;STMPE610.c,165 :: 		if (I2C1_State != 0)
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_GetFifo10
;STMPE610.c,166 :: 		UART6_PutQueue("I2C1 state error\r\n");
MOVW	R0, #lo_addr(?lstr1_STMPE610+0)
MOVT	R0, #hi_addr(?lstr1_STMPE610+0)
BL	_UART6_PutQueue+0
IT	AL
BAL	L_GetFifo11
L_GetFifo10:
;STMPE610.c,168 :: 		ReadRegs(CmdFifo[CmdFifoOut].RegAd,CmdFifo[CmdFifoOut].Count,CmdFifo[CmdFifoOut].Buff);
MOVW	R0, #lo_addr(_CmdFifoOut+0)
MOVT	R0, #hi_addr(_CmdFifoOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #3
MOVW	R0, #lo_addr(_CmdFifo+0)
MOVT	R0, #hi_addr(_CmdFifo+0)
ADDS	R3, R0, R1
LDR	R0, [R3, #0]
MOV	R2, R0
ADDS	R0, R3, #6
LDRB	R0, [R0, #0]
UXTB	R1, R0
ADDS	R0, R3, #5
LDRB	R0, [R0, #0]
BL	_ReadRegs+0
L_GetFifo11:
;STMPE610.c,169 :: 		break;
IT	AL
BAL	L_GetFifo4
;STMPE610.c,171 :: 		default:
L_GetFifo12:
;STMPE610.c,172 :: 		UART6_PutQueue("Unknown command\r\n");
MOVW	R0, #lo_addr(?lstr2_STMPE610+0)
MOVT	R0, #hi_addr(?lstr2_STMPE610+0)
BL	_UART6_PutQueue+0
;STMPE610.c,173 :: 		break;
IT	AL
BAL	L_GetFifo4
;STMPE610.c,174 :: 		}
L_GetFifo3:
LDR	R1, [SP, #4]
LDRB	R0, [R1, #0]
CMP	R0, #1
IT	EQ
BEQ	L_GetFifo5
LDRB	R0, [R1, #0]
CMP	R0, #2
IT	EQ
BEQ	L_GetFifo9
IT	AL
BAL	L_GetFifo12
L_GetFifo4:
;STMPE610.c,175 :: 		if (++CmdFifoOut > (CMDFIFOLEN - 1)) { // Adjust fifo out pointer
MOVW	R1, #lo_addr(_CmdFifoOut+0)
MOVT	R1, #hi_addr(_CmdFifoOut+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R1, #0]
CMP	R0, #255
IT	LS
BLS	L_GetFifo13
;STMPE610.c,176 :: 		CmdFifoOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_CmdFifoOut+0)
MOVT	R0, #hi_addr(_CmdFifoOut+0)
STRB	R1, [R0, #0]
;STMPE610.c,177 :: 		}
L_GetFifo13:
;STMPE610.c,178 :: 		return 0;                 // Return command sent to I2C1
MOVS	R0, #0
IT	AL
BAL	L_end_GetFifo
;STMPE610.c,179 :: 		} else return 1;              // Return fifo empty status
L_GetFifo2:
MOVS	R0, #1
IT	AL
BAL	L_end_GetFifo
;STMPE610.c,180 :: 		} else  return (-1);              // Return I2C1 busy status
L_GetFifo1:
MOVS	R0, #-1
;STMPE610.c,182 :: 		}
L_end_GetFifo:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _GetFifo
_STMPE_TimeoutCheck:
;STMPE610.c,188 :: 		void STMPE_TimeoutCheck(unsigned TimeoutState) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
STRH	R0, [SP, #8]
;STMPE610.c,191 :: 		if (check_timer(STMPETimer) == 0) {         // If timeout
MOVW	R1, #lo_addr(_STMPETimer+0)
MOVT	R1, #hi_addr(_STMPETimer+0)
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L_STMPE_TimeoutCheck16
;STMPE610.c,193 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #4]
;STMPE610.c,194 :: 		sprintf(BufNum,"STMPE has timed out in state %d\r\n",TimeoutState);
MOVW	R3, #lo_addr(?lstr_3_STMPE610+0)
MOVT	R3, #hi_addr(?lstr_3_STMPE610+0)
MOV	R2, R0
LDRH	R1, [SP, #8]
PUSH	(R1)
PUSH	(R3)
PUSH	(R2)
BL	_sprintf+0
ADD	SP, SP, #12
;STMPE610.c,195 :: 		UART6_PutQueue(BufNum);
LDR	R0, [SP, #4]
BL	_UART6_PutQueue+0
;STMPE610.c,196 :: 		free_timer(STMPETimer);                 // Release Wi-Fi timer back to the pool
MOVW	R1, #lo_addr(_STMPETimer+0)
MOVT	R1, #hi_addr(_STMPETimer+0)
LDRB	R1, [R1, #0]
UXTB	R0, R1
BL	_free_timer+0
;STMPE610.c,197 :: 		STMPE_State = 0;                        // Return to holding state
MOVS	R2, #0
MOVW	R1, #lo_addr(_STMPE_State+0)
MOVT	R1, #hi_addr(_STMPE_State+0)
STRB	R2, [R1, #0]
;STMPE610.c,198 :: 		}
L_STMPE_TimeoutCheck16:
;STMPE610.c,199 :: 		}
L_end_STMPE_TimeoutCheck:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _STMPE_TimeoutCheck
_STMPE_SM:
;STMPE610.c,204 :: 		void STMPE_SM(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;STMPE610.c,213 :: 		switch (STMPE_State) {
IT	AL
BAL	L_STMPE_SM17
;STMPE610.c,214 :: 		case 0: // Hold here if the interrupt flag is clear
L_STMPE_SM19:
;STMPE610.c,215 :: 		if (IntFlag) {            // Interrupt flag?
MOVW	R0, #lo_addr(_IntFlag+0)
MOVT	R0, #hi_addr(_IntFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_STMPE_SM20
;STMPE610.c,216 :: 		IntFlag = 0;          // Clear the interrupt flag
MOVS	R1, #0
MOVW	R0, #lo_addr(_IntFlag+0)
MOVT	R0, #hi_addr(_IntFlag+0)
STRB	R1, [R0, #0]
;STMPE610.c,219 :: 		STMPE_State = 18;     // Go service the interrupt
MOVS	R1, #18
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,220 :: 		}
L_STMPE_SM20:
;STMPE610.c,221 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,226 :: 		case 1: // Get a timer handle and set timeout value
L_STMPE_SM21:
;STMPE610.c,227 :: 		STMPETimer = get_timer();                // Get a timer handle
BL	_get_timer+0
MOVW	R1, #lo_addr(_STMPETimer+0)
MOVT	R1, #hi_addr(_STMPETimer+0)
STRB	R0, [R1, #0]
;STMPE610.c,228 :: 		set_timer(STMPETimer,5000);              // Set timer
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,229 :: 		STMPE_State = 2;
MOVS	R1, #2
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,230 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,232 :: 		case 2: // Execute a soft reset to the STMPE610
L_STMPE_SM22:
;STMPE610.c,233 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM23
;STMPE610.c,234 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,235 :: 		CmdBufNum[0] = 0x02;                 // Soft reset
MOVS	R1, #2
STRB	R1, [R0, #0]
;STMPE610.c,236 :: 		PutFifo(CmdBufNum,WR,SYS_CTRL1,1);   // Reg 0x03 SYS_CTRL1
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #3
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,238 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,239 :: 		STMPE_State = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,240 :: 		}
L_STMPE_SM23:
;STMPE610.c,241 :: 		STMPE_TimeoutCheck(2);
MOVS	R0, #2
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,242 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,244 :: 		case 3: // Turn on all module clocks
L_STMPE_SM24:
;STMPE610.c,245 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM25
;STMPE610.c,246 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,247 :: 		CmdBufNum[0] = 0x00;                 // All clocks on
MOVS	R1, #0
STRB	R1, [R0, #0]
;STMPE610.c,248 :: 		PutFifo(CmdBufNum,WR,SYS_CTRL2,1);   // Reg 0x04 SYS_CTRL2
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #4
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,250 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,251 :: 		STMPE_State = 4;
MOVS	R1, #4
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,252 :: 		}
L_STMPE_SM25:
;STMPE610.c,253 :: 		STMPE_TimeoutCheck(3);
MOVS	R0, #3
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,254 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,256 :: 		case 4: // Make unused pins into GPIO ports
L_STMPE_SM26:
;STMPE610.c,257 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM27
;STMPE610.c,258 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,259 :: 		CmdBufNum[0] = 0x0C;                 // GPIO 2 and 3 are alternate function
MOVS	R1, #12
STRB	R1, [R0, #0]
;STMPE610.c,260 :: 		PutFifo(CmdBufNum,WR,GPIO_AF,1);     // Reg 0x17 GPIO_AF
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #23
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,262 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,263 :: 		STMPE_State = 5;
MOVS	R1, #5
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,264 :: 		}
L_STMPE_SM27:
;STMPE610.c,265 :: 		STMPE_TimeoutCheck(4);
MOVS	R0, #4
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,266 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,268 :: 		case 5: // Set unused GPIO ports to outputs
L_STMPE_SM28:
;STMPE610.c,269 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM29
;STMPE610.c,270 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,271 :: 		CmdBufNum[0] = 0x0C;                 // GPIO 2 and 3 are outputs
MOVS	R1, #12
STRB	R1, [R0, #0]
;STMPE610.c,272 :: 		PutFifo(CmdBufNum,WR,GPIO_DIR,1);    // Reg 0x13 GPIO_DIR
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #19
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,274 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,275 :: 		STMPE_State = 6;
MOVS	R1, #6
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,276 :: 		}
L_STMPE_SM29:
;STMPE610.c,277 :: 		STMPE_TimeoutCheck(5);
MOVS	R0, #5
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,278 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,280 :: 		case 6: // Set up ADC
L_STMPE_SM30:
;STMPE610.c,281 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM31
;STMPE610.c,282 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,283 :: 		CmdBufNum[0] = 0x48;                 // Sample time  to 80, 12-bit ADC, internal reference
MOVS	R1, #72
STRB	R1, [R0, #0]
;STMPE610.c,284 :: 		PutFifo(CmdBufNum,WR,ADC_CTRL1,1);   // Reg 0x20 ADC_CTRL1
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #32
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,286 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,287 :: 		STMPE_State = 7;
MOVS	R1, #7
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,288 :: 		}
L_STMPE_SM31:
;STMPE610.c,289 :: 		STMPE_TimeoutCheck(6);
MOVS	R0, #6
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,290 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,292 :: 		case 7: // Set ADC frequency
L_STMPE_SM32:
;STMPE610.c,293 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM33
;STMPE610.c,294 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,295 :: 		CmdBufNum[0] = 0x01;                 // ADC frequency to 3.25 MHz
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,296 :: 		PutFifo(CmdBufNum,WR,ADC_CTRL2,1);   // Reg 0x21 ADC_CTRL2
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #33
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,298 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,299 :: 		STMPE_State = 8;
MOVS	R1, #8
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,300 :: 		}
L_STMPE_SM33:
;STMPE610.c,301 :: 		STMPE_TimeoutCheck(7);
MOVS	R0, #7
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,302 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,304 :: 		case 8: // Set up touch delays
L_STMPE_SM34:
;STMPE610.c,305 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM35
;STMPE610.c,306 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,309 :: 		CmdBufNum[0] = 0xB5;                 // Average 4 samples, 10 ms touch delay 10 ms settling time
MOVS	R1, #181
STRB	R1, [R0, #0]
;STMPE610.c,313 :: 		PutFifo(CmdBufNum,WR,TSC_CFG,1);     // Reg 0x41 TSC_CFG
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #65
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,315 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,316 :: 		STMPE_State = 9;
MOVS	R1, #9
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,317 :: 		}
L_STMPE_SM35:
;STMPE610.c,318 :: 		STMPE_TimeoutCheck(8);
MOVS	R0, #8
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,319 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,321 :: 		case 9: // Only 1 point FIFO mode
L_STMPE_SM36:
;STMPE610.c,322 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM37
;STMPE610.c,323 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,324 :: 		CmdBufNum[0] = 0x01;                 // Single point reading method
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,325 :: 		PutFifo(CmdBufNum,WR,FIFO_TH,1);     // Reg 0x4A FIFO_TH
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #74
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,327 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,328 :: 		STMPE_State = 10;
MOVS	R1, #10
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,329 :: 		}
L_STMPE_SM37:
;STMPE610.c,330 :: 		STMPE_TimeoutCheck(9);
MOVS	R0, #9
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,331 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,333 :: 		case 10: // Reset FIFO to clear it
L_STMPE_SM38:
;STMPE610.c,334 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM39
;STMPE610.c,335 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,336 :: 		CmdBufNum[0] = 0x01;                 // FIFO reset
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,337 :: 		PutFifo(CmdBufNum,WR,FIFO_STA,1);    // Reg 0x4B FIFO_STA
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #75
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,339 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,340 :: 		STMPE_State = 11;
MOVS	R1, #11
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,341 :: 		}
L_STMPE_SM39:
;STMPE610.c,342 :: 		STMPE_TimeoutCheck(10);
MOVS	R0, #10
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,343 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,345 :: 		case 11: // More setups
L_STMPE_SM40:
;STMPE610.c,346 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM41
;STMPE610.c,347 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,348 :: 		CmdBufNum[0] = 0x07;                 // Fractional part to 7, whole part to 1
MOVS	R1, #7
STRB	R1, [R0, #0]
;STMPE610.c,349 :: 		PutFifo(CmdBufNum,WR,TSC_FRACTION_Z,1); // Reg 0x56 TSC_FRACTION_Z
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #86
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,351 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,352 :: 		STMPE_State = 12;
MOVS	R1, #12
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,353 :: 		}
L_STMPE_SM41:
;STMPE610.c,354 :: 		STMPE_TimeoutCheck(11);
MOVS	R0, #11
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,355 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,357 :: 		case 12: // Set maximum drive current
L_STMPE_SM42:
;STMPE610.c,358 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM43
;STMPE610.c,359 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,361 :: 		CmdBufNum[0] = 0x00;                 // I drive for 20 mA max
MOVS	R1, #0
STRB	R1, [R0, #0]
;STMPE610.c,362 :: 		PutFifo(CmdBufNum,WR,TSC_I_DRIVE,1); // Reg 0x58 TSC_I_DRIVE
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #88
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,364 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,365 :: 		STMPE_State = 13;
MOVS	R1, #13
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,366 :: 		}
L_STMPE_SM43:
;STMPE610.c,367 :: 		STMPE_TimeoutCheck(12);
MOVS	R0, #12
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,368 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,370 :: 		case 13: // Enable TSC. This also clears FIFO reset
L_STMPE_SM44:
;STMPE610.c,371 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM45
;STMPE610.c,372 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,373 :: 		CmdBufNum[0] = 0x01;                 // Enable TSC
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,374 :: 		PutFifo(CmdBufNum,WR,TSC_CTRL,1);    // Reg 0x40 TSC_CTRL
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #64
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,376 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,377 :: 		STMPE_State = 14;
MOVS	R1, #14
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,378 :: 		}
L_STMPE_SM45:
;STMPE610.c,379 :: 		STMPE_TimeoutCheck(13);
MOVS	R0, #13
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,380 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,382 :: 		case 14: // Set FIFO threshold interrupt enable and touch detect interrupt enable
L_STMPE_SM46:
;STMPE610.c,383 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM47
;STMPE610.c,384 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,385 :: 		CmdBufNum[0] = 0x03;                 // Enable interrupts
MOVS	R1, #3
STRB	R1, [R0, #0]
;STMPE610.c,386 :: 		PutFifo(CmdBufNum,WR,INT_EN,1);      // Reg 0x0A INT_EN
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #10
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,388 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,389 :: 		STMPE_State = 15;
MOVS	R1, #15
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,390 :: 		}
L_STMPE_SM47:
;STMPE610.c,391 :: 		STMPE_TimeoutCheck(14);
MOVS	R0, #14
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,392 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,394 :: 		case 15: // Clear all interrupts
L_STMPE_SM48:
;STMPE610.c,395 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM49
;STMPE610.c,396 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,397 :: 		CmdBufNum[0] = 0xFF;                 // Clear all interrupts
MOVS	R1, #255
STRB	R1, [R0, #0]
;STMPE610.c,398 :: 		PutFifo(CmdBufNum,WR,INT_STA,1);     // Reg 0x0B INT_STA
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #11
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,400 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,401 :: 		STMPE_State = 16;
MOVS	R1, #16
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,402 :: 		}
L_STMPE_SM49:
;STMPE610.c,403 :: 		STMPE_TimeoutCheck(15);
MOVS	R0, #15
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,404 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,406 :: 		case 16: // Set up external interrupt level and global enable
L_STMPE_SM50:
;STMPE610.c,407 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM51
;STMPE610.c,408 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,409 :: 		CmdBufNum[0] = 0x03;                 // Set edge type and global int enable bits
MOVS	R1, #3
STRB	R1, [R0, #0]
;STMPE610.c,410 :: 		PutFifo(CmdBufNum,WR,INT_CTRL,1);    // Reg 0x09 INT_CTRL
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #9
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,412 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,413 :: 		STMPE_State = 17;
MOVS	R1, #17
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,414 :: 		}
L_STMPE_SM51:
;STMPE610.c,415 :: 		STMPE_TimeoutCheck(16);
MOVS	R0, #16
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,416 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,418 :: 		case 17: // Free timer and return to holding state
L_STMPE_SM52:
;STMPE610.c,419 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM53
;STMPE610.c,421 :: 		free_timer(STMPETimer);
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;STMPE610.c,422 :: 		STMPE_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,425 :: 		}
L_STMPE_SM53:
;STMPE610.c,426 :: 		STMPE_TimeoutCheck(17);
MOVS	R0, #17
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,427 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,432 :: 		case 18:
L_STMPE_SM54:
;STMPE610.c,433 :: 		STMPETimer = get_timer();                // Get a timer handle
BL	_get_timer+0
MOVW	R1, #lo_addr(_STMPETimer+0)
MOVT	R1, #hi_addr(_STMPETimer+0)
STRB	R0, [R1, #0]
;STMPE610.c,434 :: 		set_timer(STMPETimer,5000);              // Set timer
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,441 :: 		STMPE_State = 19;
MOVS	R1, #19
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,442 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,444 :: 		case 19: // Read the interrupt status register
L_STMPE_SM55:
;STMPE610.c,445 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM56
;STMPE610.c,446 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R1, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R1, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R1, #0]
;STMPE610.c,447 :: 		memset(CmdBufNum,0,8);               // Clear data buffer
MOVS	R2, #8
SXTH	R2, R2
MOVS	R1, #0
BL	_memset+0
;STMPE610.c,448 :: 		PutFifo(CmdBufNum,RD,INT_STA,1);     // Reading register 0x0B (INT_STA)
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #11
MOVS	R1, #2
BL	_PutFifo+0
;STMPE610.c,450 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,451 :: 		STMPE_State = 20; //20
MOVS	R1, #20
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,452 :: 		}
L_STMPE_SM56:
;STMPE610.c,453 :: 		STMPE_TimeoutCheck(19);
MOVS	R0, #19
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,454 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,456 :: 		case 20: // Check interrupts
L_STMPE_SM57:
;STMPE610.c,457 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) { // Data available?
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	NE
BNE	L__STMPE_SM115
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__STMPE_SM114
L__STMPE_SM113:
;STMPE610.c,459 :: 		if ((CmdBufNum[1] & 0x02) == 0x02) { // Threshold interrupt?
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, #1
LDRB	R0, [R0, #0]
AND	R0, R0, #2
UXTB	R0, R0
CMP	R0, #2
IT	NE
BNE	L_STMPE_SM61
;STMPE610.c,461 :: 		set_timer(STMPETimer,5000);      // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,462 :: 		STMPE_State = 21;
MOVS	R1, #21
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,463 :: 		} else if ((CmdBufNum[1] & 0x01) == 0x01) { // Touch detect interrupt?
IT	AL
BAL	L_STMPE_SM62
L_STMPE_SM61:
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, #1
LDRB	R0, [R0, #0]
AND	R0, R0, #1
UXTB	R0, R0
CMP	R0, #1
IT	NE
BNE	L_STMPE_SM63
;STMPE610.c,465 :: 		if (PenDown == 0) {
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM64
;STMPE610.c,466 :: 		PenDown = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;STMPE610.c,468 :: 		} else if (PenDown == 1) {
IT	AL
BAL	L_STMPE_SM65
L_STMPE_SM64:
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_STMPE_SM66
;STMPE610.c,469 :: 		PenDown = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;STMPE610.c,471 :: 		Process_TP_Up(Xcoord,Ycoord);
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	_Process_TP_Up+0
;STMPE610.c,472 :: 		}
L_STMPE_SM66:
L_STMPE_SM65:
;STMPE610.c,474 :: 		set_timer(STMPETimer,5000);      // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,475 :: 		STMPE_State = 28;
MOVS	R1, #28
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,476 :: 		} else {
IT	AL
BAL	L_STMPE_SM67
L_STMPE_SM63:
;STMPE610.c,478 :: 		set_timer(STMPETimer,5000);      // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,479 :: 		STMPE_State = 28;
MOVS	R1, #28
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,480 :: 		}
L_STMPE_SM67:
L_STMPE_SM62:
;STMPE610.c,457 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) { // Data available?
L__STMPE_SM115:
L__STMPE_SM114:
;STMPE610.c,482 :: 		STMPE_TimeoutCheck(20);
MOVS	R0, #20
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,483 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,486 :: 		case 21: // Get number of points available in FIFO
L_STMPE_SM68:
;STMPE610.c,487 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM69
;STMPE610.c,488 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R1, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R1, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R1, #0]
;STMPE610.c,489 :: 		memset(CmdBufNum,0,8);               // Clear data buffer
MOVS	R2, #8
SXTH	R2, R2
MOVS	R1, #0
BL	_memset+0
;STMPE610.c,490 :: 		PutFifo(CmdBufNum,RD,FIFO_SIZE,1);   // Reading register 0x4C (FIFO_SIZE)
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #76
MOVS	R1, #2
BL	_PutFifo+0
;STMPE610.c,492 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,493 :: 		STMPE_State = 22;
MOVS	R1, #22
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,494 :: 		}
L_STMPE_SM69:
;STMPE610.c,495 :: 		STMPE_TimeoutCheck(21);
MOVS	R0, #21
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,496 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,498 :: 		case 22: // Wait to receive number of points data
L_STMPE_SM70:
;STMPE610.c,499 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) { // Data available?
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	NE
BNE	L__STMPE_SM117
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__STMPE_SM116
L__STMPE_SM112:
;STMPE610.c,501 :: 		Size = CmdBufNum[1];
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, #1
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(STMPE_SM_Size_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_Size_L0+0)
STRB	R1, [R0, #0]
;STMPE610.c,502 :: 		Number = Size*4;                 // 4 bytes of data for each point
LSLS	R1, R1, #2
MOVW	R0, #lo_addr(STMPE_SM_Number_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_Number_L0+0)
STRH	R1, [R0, #0]
;STMPE610.c,503 :: 		STMPE_State = 23;
MOVS	R1, #23
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,499 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) { // Data available?
L__STMPE_SM117:
L__STMPE_SM116:
;STMPE610.c,511 :: 		STMPE_TimeoutCheck(22);
MOVS	R0, #22
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,512 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,514 :: 		case 23: // Read data from FIFO according to number of points
L_STMPE_SM74:
;STMPE610.c,515 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM75
;STMPE610.c,517 :: 		CmdBufNum = &BigBuffer;              // Use bigger buffer just in case
MOVW	R1, #lo_addr(_BigBuffer+0)
MOVT	R1, #hi_addr(_BigBuffer+0)
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R1, [R0, #0]
;STMPE610.c,518 :: 		memset(CmdBufNum,0,8);               // Clear data buffer
LDR	R0, [R0, #0]
MOVS	R2, #8
SXTH	R2, R2
MOVS	R1, #0
BL	_memset+0
;STMPE610.c,519 :: 		PutFifo(CmdBufNum,RD,TSC_DATA_1,Number); // Reading FOFO data 0xD7 (TSC_DATA_1)
MOVW	R0, #lo_addr(STMPE_SM_Number_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_Number_L0+0)
LDRSH	R1, [R0, #0]
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
UXTB	R3, R1
MOVS	R2, #215
MOVS	R1, #2
BL	_PutFifo+0
;STMPE610.c,521 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,522 :: 		STMPE_State = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,523 :: 		}
L_STMPE_SM75:
;STMPE610.c,524 :: 		STMPE_TimeoutCheck(23);
MOVS	R0, #23
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,525 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,527 :: 		case 24: // Wait for data then extract X, Y, and Z values
L_STMPE_SM76:
;STMPE610.c,528 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0) && (Size > 1)) {
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	NE
BNE	L__STMPE_SM120
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__STMPE_SM119
MOVW	R0, #lo_addr(STMPE_SM_Size_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_Size_L0+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	LS
BLS	L__STMPE_SM118
L__STMPE_SM111:
;STMPE610.c,530 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,531 :: 		STMPE_State = 25;                    // Don't process data
MOVS	R1, #25
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,533 :: 		} else if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0) && (Size == 1)) {
IT	AL
BAL	L_STMPE_SM80
;STMPE610.c,528 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0) && (Size > 1)) {
L__STMPE_SM120:
L__STMPE_SM119:
L__STMPE_SM118:
;STMPE610.c,533 :: 		} else if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0) && (Size == 1)) {
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	NE
BNE	L__STMPE_SM123
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__STMPE_SM122
MOVW	R0, #lo_addr(STMPE_SM_Size_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_Size_L0+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L__STMPE_SM121
L__STMPE_SM110:
;STMPE610.c,534 :: 		X = (CmdBufNum[1] << 4) | ((CmdBufNum[2] & 0xF0) >> 4);
MOVW	R4, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R4, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R4, #0]
ADDS	R0, R0, #1
LDRB	R0, [R0, #0]
LSLS	R2, R0, #4
UXTH	R2, R2
MOV	R0, R4
LDR	R0, [R0, #0]
ADDS	R1, R0, #2
LDRB	R0, [R1, #0]
AND	R0, R0, #240
UXTB	R0, R0
LSRS	R0, R0, #4
UXTB	R0, R0
ORR	R3, R2, R0, LSL #0
UXTH	R3, R3
MOVW	R0, #lo_addr(_X+0)
MOVT	R0, #hi_addr(_X+0)
STRH	R3, [R0, #0]
;STMPE610.c,535 :: 		Y = ((CmdBufNum[2] & 0x0F) << 8) | CmdBufNum[3];
LDRB	R0, [R1, #0]
AND	R0, R0, #15
UXTB	R0, R0
LSLS	R1, R0, #8
UXTH	R1, R1
MOV	R0, R4
LDR	R0, [R0, #0]
ADDS	R0, R0, #3
LDRB	R0, [R0, #0]
ORR	R2, R1, R0, LSL #0
UXTH	R2, R2
MOVW	R0, #lo_addr(_Y+0)
MOVT	R0, #hi_addr(_Y+0)
STRH	R2, [R0, #0]
;STMPE610.c,536 :: 		Z = CmdBufNum[4];
MOV	R0, R4
LDR	R0, [R0, #0]
ADDS	R0, R0, #4
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_Z+0)
MOVT	R0, #hi_addr(_Z+0)
STRB	R1, [R0, #0]
;STMPE610.c,539 :: 		XNum = X / 8.6; YNum = Y / 14.8;     // Scale touch panel to display pixels
VMOV	S1, R3
VCVT.F32	#0, S1, S1
MOVW	R0, #39322
MOVT	R0, #16649
VMOV	S0, R0
VDIV.F32	S2, S1, S0
MOVW	R0, #lo_addr(_XNum+0)
MOVT	R0, #hi_addr(_XNum+0)
VSTR	#1, S2, [R0, #0]
VMOV	S1, R2
VCVT.F32	#0, S1, S1
MOVW	R0, #52429
MOVT	R0, #16748
VMOV	S0, R0
VDIV.F32	S1, S1, S0
MOVW	R0, #lo_addr(_YNum+0)
MOVT	R0, #hi_addr(_YNum+0)
VSTR	#1, S1, [R0, #0]
;STMPE610.c,541 :: 		Xcoord = (unsigned)XNum;
VCVT	#1, .F32, S0, S2
VMOV	R1, S0
UXTH	R1, R1
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
STRH	R1, [R0, #0]
;STMPE610.c,542 :: 		Ycoord = (unsigned)YNum;
VCVT	#1, .F32, S0, S1
VMOV	R1, S0
UXTH	R1, R1
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
STRH	R1, [R0, #0]
;STMPE610.c,550 :: 		if (ActiveFlag == 0) {
MOVW	R0, #lo_addr(_ActiveFlag+0)
MOVT	R0, #hi_addr(_ActiveFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM84
;STMPE610.c,551 :: 		ActiveFlag = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_ActiveFlag+0)
MOVT	R0, #hi_addr(_ActiveFlag+0)
STRB	R1, [R0, #0]
;STMPE610.c,552 :: 		Process_TP_Press(Xcoord,Ycoord);
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	_Process_TP_Press+0
;STMPE610.c,553 :: 		Process_TP_Down(Xcoord,Ycoord);
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	_Process_TP_Down+0
;STMPE610.c,554 :: 		}
L_STMPE_SM84:
;STMPE610.c,555 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,556 :: 		STMPE_State = 25;
MOVS	R1, #25
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,533 :: 		} else if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0) && (Size == 1)) {
L__STMPE_SM123:
L__STMPE_SM122:
L__STMPE_SM121:
;STMPE610.c,557 :: 		}
L_STMPE_SM80:
;STMPE610.c,558 :: 		STMPE_TimeoutCheck(24);
MOVS	R0, #24
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,559 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,562 :: 		case 25: // Reset FIFO
L_STMPE_SM85:
;STMPE610.c,563 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM86
;STMPE610.c,564 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,565 :: 		CmdBufNum[0] = 0x01;                 // FIFO reset
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,566 :: 		PutFifo(CmdBufNum,WR,FIFO_STA,1);    // Reg 0x4B FIFO_STA
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #75
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,568 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,569 :: 		STMPE_State = 26;
MOVS	R1, #26
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,570 :: 		}
L_STMPE_SM86:
;STMPE610.c,571 :: 		STMPE_TimeoutCheck(25);
MOVS	R0, #25
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,572 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,574 :: 		case 26: // Enable TSC. This also clears FIFO reset
L_STMPE_SM87:
;STMPE610.c,575 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM88
;STMPE610.c,576 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,577 :: 		CmdBufNum[0] = 0x01;                 // Enable TSC
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,578 :: 		PutFifo(CmdBufNum,WR,TSC_CTRL,1);    // Reg 0x40 TSC_CTRL
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #64
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,580 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,581 :: 		STMPE_State = 27;
MOVS	R1, #27
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,582 :: 		}
L_STMPE_SM88:
;STMPE610.c,583 :: 		STMPE_TimeoutCheck(26);
MOVS	R0, #26
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,584 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,586 :: 		case 27: // Clear interrupts
L_STMPE_SM89:
;STMPE610.c,587 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM90
;STMPE610.c,588 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,589 :: 		CmdBufNum[0] = 0x02;                 // Clear FIFO threshold interrupt
MOVS	R1, #2
STRB	R1, [R0, #0]
;STMPE610.c,590 :: 		PutFifo(CmdBufNum,WR,INT_STA,1);     // Writing register 0x0B (INT_STA)
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #11
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,592 :: 		set_timer(STMPETimer,50);            // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVS	R1, #50
BL	_set_timer+0
;STMPE610.c,593 :: 		STMPE_State = 34;
MOVS	R1, #34
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,594 :: 		}
L_STMPE_SM90:
;STMPE610.c,595 :: 		STMPE_TimeoutCheck(27);
MOVS	R0, #27
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,596 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,599 :: 		case 28: // Get number of points available in FIFO
L_STMPE_SM91:
;STMPE610.c,600 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM92
;STMPE610.c,601 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R1, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R1, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R1, #0]
;STMPE610.c,602 :: 		memset(CmdBufNum,0,8);               // Clear data buffer
MOVS	R2, #8
SXTH	R2, R2
MOVS	R1, #0
BL	_memset+0
;STMPE610.c,603 :: 		PutFifo(CmdBufNum,RD,FIFO_SIZE,1);   // Reading register 0x4C (FIFO_SIZE)
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #76
MOVS	R1, #2
BL	_PutFifo+0
;STMPE610.c,605 :: 		set_timer(STMPETimer,100);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVS	R1, #100
BL	_set_timer+0
;STMPE610.c,606 :: 		STMPE_State = 29;
MOVS	R1, #29
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,607 :: 		}
L_STMPE_SM92:
;STMPE610.c,608 :: 		STMPE_TimeoutCheck(28);
MOVS	R0, #28
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,609 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,611 :: 		case 29: // Wait to receive number of points data
L_STMPE_SM93:
;STMPE610.c,612 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) {
MOVW	R0, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R0, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
LDR	R0, [R0, #0]
LDRB	R0, [R0, #0]
CMP	R0, #255
IT	NE
BNE	L__STMPE_SM125
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__STMPE_SM124
L__STMPE_SM109:
;STMPE610.c,619 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,620 :: 		STMPE_State = 30;
MOVS	R1, #30
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,612 :: 		if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) {
L__STMPE_SM125:
L__STMPE_SM124:
;STMPE610.c,622 :: 		STMPE_TimeoutCheck(29);
MOVS	R0, #29
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,623 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,625 :: 		case 30: // On Button up interrupt, clear first time flag
L_STMPE_SM97:
;STMPE610.c,626 :: 		if (ActiveFlag == 1)
MOVW	R0, #lo_addr(_ActiveFlag+0)
MOVT	R0, #hi_addr(_ActiveFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_STMPE_SM98
;STMPE610.c,627 :: 		ActiveFlag = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_ActiveFlag+0)
MOVT	R0, #hi_addr(_ActiveFlag+0)
STRB	R1, [R0, #0]
L_STMPE_SM98:
;STMPE610.c,629 :: 		set_timer(STMPETimer,5000);              // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,630 :: 		STMPE_State = 31;
MOVS	R1, #31
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,631 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,633 :: 		case 31: // Reset FIFO
L_STMPE_SM99:
;STMPE610.c,634 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM100
;STMPE610.c,635 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,636 :: 		CmdBufNum[0] = 0x01;                 // FIFO reset
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,637 :: 		PutFifo(CmdBufNum,WR,FIFO_STA,1);    // Reg 0x4B FIFO_STA
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #75
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,639 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,640 :: 		STMPE_State = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,641 :: 		}
L_STMPE_SM100:
;STMPE610.c,642 :: 		STMPE_TimeoutCheck(31);
MOVS	R0, #31
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,643 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,645 :: 		case 32: // Enable TSC. This also clears FIFO reset
L_STMPE_SM101:
;STMPE610.c,646 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM102
;STMPE610.c,647 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,648 :: 		CmdBufNum[0] = 0x01;                 // Enable TSC
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,649 :: 		PutFifo(CmdBufNum,WR,TSC_CTRL,1);    // Reg 0x40 TSC_CTRL
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #64
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,651 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,652 :: 		STMPE_State = 33;
MOVS	R1, #33
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,653 :: 		}
L_STMPE_SM102:
;STMPE610.c,654 :: 		STMPE_TimeoutCheck(32);
MOVS	R0, #32
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,655 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,657 :: 		case 33: // Clear interrupts
L_STMPE_SM103:
;STMPE610.c,658 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM104
;STMPE610.c,659 :: 		CmdBufNum = GetCmdBuf();
BL	_GetCmdBuf+0
MOVW	R2, #lo_addr(STMPE_SM_CmdBufNum_L0+0)
MOVT	R2, #hi_addr(STMPE_SM_CmdBufNum_L0+0)
STR	R0, [R2, #0]
;STMPE610.c,660 :: 		CmdBufNum[0] = 0x01;                 // Clear touch detect interrupt
MOVS	R1, #1
STRB	R1, [R0, #0]
;STMPE610.c,661 :: 		PutFifo(CmdBufNum,WR,INT_STA,1);     // Writing register 0x0B (INT_STA)
MOV	R0, R2
LDR	R0, [R0, #0]
MOVS	R3, #1
MOVS	R2, #11
MOVS	R1, #1
BL	_PutFifo+0
;STMPE610.c,663 :: 		set_timer(STMPETimer,50);            // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVS	R1, #50
BL	_set_timer+0
;STMPE610.c,664 :: 		STMPE_State = 34;
MOVS	R1, #34
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,665 :: 		}
L_STMPE_SM104:
;STMPE610.c,666 :: 		STMPE_TimeoutCheck(33);
MOVS	R0, #33
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,667 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,671 :: 		case 34: // Small delay after clearing interrupts
L_STMPE_SM105:
;STMPE610.c,672 :: 		if (check_timer(STMPETimer) == 0) {
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM106
;STMPE610.c,673 :: 		set_timer(STMPETimer,5000);          // Set timer
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #5000
BL	_set_timer+0
;STMPE610.c,674 :: 		STMPE_State = 35;
MOVS	R1, #35
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,675 :: 		}
L_STMPE_SM106:
;STMPE610.c,676 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,678 :: 		case 35: // Free timer and go back to start
L_STMPE_SM107:
;STMPE610.c,679 :: 		if (I2C1_State == 0) {
MOVW	R0, #lo_addr(_I2C1_State+0)
MOVT	R0, #hi_addr(_I2C1_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_STMPE_SM108
;STMPE610.c,681 :: 		free_timer(STMPETimer);
MOVW	R0, #lo_addr(_STMPETimer+0)
MOVT	R0, #hi_addr(_STMPETimer+0)
LDRB	R0, [R0, #0]
BL	_free_timer+0
;STMPE610.c,682 :: 		STMPE_State = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
STRB	R1, [R0, #0]
;STMPE610.c,684 :: 		NVIC_IntEnable(IVT_INT_EXTI0);  // Enable EXTI0 interrupt
MOVW	R0, #22
BL	_NVIC_IntEnable+0
;STMPE610.c,685 :: 		}
L_STMPE_SM108:
;STMPE610.c,686 :: 		STMPE_TimeoutCheck(35);
MOVS	R0, #35
BL	_STMPE_TimeoutCheck+0
;STMPE610.c,687 :: 		break;
IT	AL
BAL	L_STMPE_SM18
;STMPE610.c,688 :: 		}
L_STMPE_SM17:
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_STMPE_SM19
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_STMPE_SM21
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_STMPE_SM22
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #3
IT	EQ
BEQ	L_STMPE_SM24
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #4
IT	EQ
BEQ	L_STMPE_SM26
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #5
IT	EQ
BEQ	L_STMPE_SM28
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #6
IT	EQ
BEQ	L_STMPE_SM30
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #7
IT	EQ
BEQ	L_STMPE_SM32
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #8
IT	EQ
BEQ	L_STMPE_SM34
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #9
IT	EQ
BEQ	L_STMPE_SM36
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #10
IT	EQ
BEQ	L_STMPE_SM38
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #11
IT	EQ
BEQ	L_STMPE_SM40
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #12
IT	EQ
BEQ	L_STMPE_SM42
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #13
IT	EQ
BEQ	L_STMPE_SM44
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #14
IT	EQ
BEQ	L_STMPE_SM46
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #15
IT	EQ
BEQ	L_STMPE_SM48
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #16
IT	EQ
BEQ	L_STMPE_SM50
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #17
IT	EQ
BEQ	L_STMPE_SM52
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #18
IT	EQ
BEQ	L_STMPE_SM54
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #19
IT	EQ
BEQ	L_STMPE_SM55
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #20
IT	EQ
BEQ	L_STMPE_SM57
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #21
IT	EQ
BEQ	L_STMPE_SM68
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #22
IT	EQ
BEQ	L_STMPE_SM70
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #23
IT	EQ
BEQ	L_STMPE_SM74
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #24
IT	EQ
BEQ	L_STMPE_SM76
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #25
IT	EQ
BEQ	L_STMPE_SM85
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #26
IT	EQ
BEQ	L_STMPE_SM87
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #27
IT	EQ
BEQ	L_STMPE_SM89
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #28
IT	EQ
BEQ	L_STMPE_SM91
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #29
IT	EQ
BEQ	L_STMPE_SM93
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #30
IT	EQ
BEQ	L_STMPE_SM97
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #31
IT	EQ
BEQ	L_STMPE_SM99
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #32
IT	EQ
BEQ	L_STMPE_SM101
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #33
IT	EQ
BEQ	L_STMPE_SM103
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #34
IT	EQ
BEQ	L_STMPE_SM105
MOVW	R0, #lo_addr(_STMPE_State+0)
MOVT	R0, #hi_addr(_STMPE_State+0)
LDRB	R0, [R0, #0]
CMP	R0, #35
IT	EQ
BEQ	L_STMPE_SM107
L_STMPE_SM18:
;STMPE610.c,689 :: 		}
L_end_STMPE_SM:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _STMPE_SM
