#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/stmpe610.h"
#line 66 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/stmpe610.h"
typedef struct {
 char *Buff;
 char CmdCode;
 char RegAd;
 char Count;
} TCommand;



void ExtIntEnable(void);
void ExtIntEnable(void);

void PutFifo(char *Bfr, char Cmd, char Addr, char Cnt);
char GetFifo(void);
void STMPE_TimeoutCheck(unsigned TimeoutState);
void STMPE_SM(void);


void Set_Index(unsigned short index);
void Write_Command(unsigned short cmd);
void Write_Data(unsigned int _data);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
#line 11 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
#line 17 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
char* GetCmdBuf(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
#line 19 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/common.h"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/i2c.h"
#line 15 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/i2c.h"
void I2C1_Initialize(void);
void ReadRegs(char Addr, char Cnt, char *Bfr);
void WriteRegs(char Addr, char Cnt, char *Bfr);
void DisplayData(char *Bfr, char Cnt);
void TimeoutCheck(unsigned TimeoutState);

void I2C1_SM(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
#line 9 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/rgb.h"
#line 13 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/rgb.h"
void RGB_Init(void);
void RGB_Set_Red(void);
void RGB_Clr_Red(void);
void RGB_Set_Green(void);
void RGB_Clr_Green(void);
void RGB_Set_Blue(void);
void RGB_Clr_Blue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/tp_test_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct CircleButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircleButton;

typedef struct CheckBox {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Checked;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Rounded;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCheckBox;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CircleButtonsCount;
 TCircleButton * const code *CircleButtons;
 unsigned int CheckBoxesCount;
 TCheckBox * const code *CheckBoxes;
};

extern TScreen Screen1;
extern TButton Button1;
extern TButton_Round ButtonRound1;
extern TCircleButton CircleButton1;
extern TLabel Label1;
extern TCheckBox CheckBox1;
extern TButton * const code Screen1_Buttons[1];
extern TButton_Round * const code Screen1_Buttons_Round[1];
extern TLabel * const code Screen1_Labels[1];
extern TCircleButton * const code Screen1_CircleButtons[1];
extern TCheckBox * const code Screen1_CheckBoxes[1];




void Button1OnPress();
void ButtonRound1OnPress();
void CheckBox1OnPress();
void CircleButton1OnPress();




extern char Button1_Caption[];
extern char ButtonRound1_Caption[];
extern char CircleButton1_Caption[];
extern char Label1_Caption[];
extern char CheckBox1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawCircleButton(TCircleButton *ACircle_button);
void DrawCheckBox(TCheckBox *ACheckBox);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 43 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
char IntFlag = 0;
char ActiveFlag = 0;

char STMPE_State = 0;
unsigned short int STMPETimer;

TCommand CmdFifo[ 256 ];
char CmdFifoIn = 0;
char CmdFifoOut = 0;

unsigned int X;
unsigned int Y;
unsigned short Z;

double XNum;
double YNum;

char BigBuffer[512];



extern char I2C1_State;
extern char RdBuffer[32];
extern char WrBuffer[32];
extern char IntFlag;
extern char PenDown;
extern char NextBuf;

extern unsigned int Xcoord, Ycoord;
#line 80 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
void ExternalInterrupt0() iv IVT_INT_EXTI0 ics ICS_AUTO {

 NVIC_IntDisable(IVT_INT_EXTI0);
 PR0_bit = 1;
 IntFlag = 1;
}
#line 90 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
void ExtIntEnable(void) {


 GPIO_Set_Pin_Mode(&GPIOA_BASE, _GPIO_PIN_0, _GPIO_CFG_MODE_INPUT | _GPIO_CFG_PULL_UP);

 MR0_bit = 1;

 TR0_bit = 0;

 TR0_EXTI_FTSR_bit = 1;

 SYSCFGEN_bit = 1;

 SYSCFG_EXTICR1 = 0x00000000;

 NVIC_IntEnable(IVT_INT_EXTI0);
}
#line 112 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
void PutFifo(char *Bfr, char Cmd, char Addr, char Cnt) {
#line 120 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 CmdFifo[CmdFifoIn].Buff = Bfr;
 CmdFifo[CmdFifoIn].CmdCode = Cmd;
 CmdFifo[CmdFifoIn].RegAd = Addr;
 CmdFifo[CmdFifoIn].Count = Cnt;

 if (++CmdFifoIn > ( 256  - 1))
 CmdFifoIn = 0;

}
#line 134 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
char GetFifo(void) {
 int i;


 if (I2C1_State == 0) {
 if (CmdFifoIn != CmdFifoOut) {
#line 148 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 switch (CmdFifo[CmdFifoOut].CmdCode) {

 case 1:
 for (i=0;i<CmdFifo[CmdFifoOut].Count;i++)
 WrBuffer[i] = *(CmdFifo[CmdFifoOut].Buff+i);

 WriteRegs(CmdFifo[CmdFifoOut].RegAd,CmdFifo[CmdFifoOut].Count,CmdFifo[CmdFifoOut].Buff);
#line 162 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 break;

 case 2:
 if (I2C1_State != 0)
 UART6_PutQueue("I2C1 state error\r\n");
 else
 ReadRegs(CmdFifo[CmdFifoOut].RegAd,CmdFifo[CmdFifoOut].Count,CmdFifo[CmdFifoOut].Buff);
 break;

 default:
 UART6_PutQueue("Unknown command\r\n");
 break;
 }
 if (++CmdFifoOut > ( 256  - 1)) {
 CmdFifoOut = 0;
 }
 return 0;
 } else return 1;
 } else return (-1);

}
#line 188 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
void STMPE_TimeoutCheck(unsigned TimeoutState) {
 char *BufNum;

 if (check_timer(STMPETimer) == 0) {

 BufNum = GetBuffer();
 sprintf(BufNum,"STMPE has timed out in state %d\r\n",TimeoutState);
 UART6_PutQueue(BufNum);
 free_timer(STMPETimer);
 STMPE_State = 0;
 }
}
#line 204 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
void STMPE_SM(void) {
#line 208 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 static char *CmdBufNum;

 static char Size;
 static int Number;

 switch (STMPE_State) {
 case 0:
 if (IntFlag) {
 IntFlag = 0;
  {} ;

 STMPE_State = 18;
 }
 break;
#line 226 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 case 1:
 STMPETimer = get_timer();
 set_timer(STMPETimer,5000);
 STMPE_State = 2;
 break;

 case 2:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x02;
 PutFifo(CmdBufNum, 0x01 , 0x03 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 3;
 }
 STMPE_TimeoutCheck(2);
 break;

 case 3:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x00;
 PutFifo(CmdBufNum, 0x01 , 0x04 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 4;
 }
 STMPE_TimeoutCheck(3);
 break;

 case 4:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x0C;
 PutFifo(CmdBufNum, 0x01 , 0x17 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 5;
 }
 STMPE_TimeoutCheck(4);
 break;

 case 5:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x0C;
 PutFifo(CmdBufNum, 0x01 , 0x13 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 6;
 }
 STMPE_TimeoutCheck(5);
 break;

 case 6:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x48;
 PutFifo(CmdBufNum, 0x01 , 0x20 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 7;
 }
 STMPE_TimeoutCheck(6);
 break;

 case 7:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x21 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 8;
 }
 STMPE_TimeoutCheck(7);
 break;

 case 8:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();


 CmdBufNum[0] = 0xB5;



 PutFifo(CmdBufNum, 0x01 , 0x41 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 9;
 }
 STMPE_TimeoutCheck(8);
 break;

 case 9:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x4A ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 10;
 }
 STMPE_TimeoutCheck(9);
 break;

 case 10:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x4B ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 11;
 }
 STMPE_TimeoutCheck(10);
 break;

 case 11:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x07;
 PutFifo(CmdBufNum, 0x01 , 0x56 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 12;
 }
 STMPE_TimeoutCheck(11);
 break;

 case 12:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();

 CmdBufNum[0] = 0x00;
 PutFifo(CmdBufNum, 0x01 , 0x58 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 13;
 }
 STMPE_TimeoutCheck(12);
 break;

 case 13:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x40 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 14;
 }
 STMPE_TimeoutCheck(13);
 break;

 case 14:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x03;
 PutFifo(CmdBufNum, 0x01 , 0x0A ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 15;
 }
 STMPE_TimeoutCheck(14);
 break;

 case 15:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0xFF;
 PutFifo(CmdBufNum, 0x01 , 0x0B ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 16;
 }
 STMPE_TimeoutCheck(15);
 break;

 case 16:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x03;
 PutFifo(CmdBufNum, 0x01 , 0x09 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 17;
 }
 STMPE_TimeoutCheck(16);
 break;

 case 17:
 if (I2C1_State == 0) {
  {} ;
 free_timer(STMPETimer);
 STMPE_State = 0;


 }
 STMPE_TimeoutCheck(17);
 break;
#line 432 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 case 18:
 STMPETimer = get_timer();
 set_timer(STMPETimer,5000);
#line 441 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 STMPE_State = 19;
 break;

 case 19:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 memset(CmdBufNum,0,8);
 PutFifo(CmdBufNum, 0x02 , 0x0B ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 20;
 }
 STMPE_TimeoutCheck(19);
 break;

 case 20:
 if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) {

 if ((CmdBufNum[1] & 0x02) == 0x02) {
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 21;
 } else if ((CmdBufNum[1] & 0x01) == 0x01) {

 if (PenDown == 0) {
 PenDown = 1;

 } else if (PenDown == 1) {
 PenDown = 0;

 Process_TP_Up(Xcoord,Ycoord);
 }
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 28;
 } else {
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 28;
 }
 }
 STMPE_TimeoutCheck(20);
 break;


 case 21:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 memset(CmdBufNum,0,8);
 PutFifo(CmdBufNum, 0x02 , 0x4C ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 22;
 }
 STMPE_TimeoutCheck(21);
 break;

 case 22:
 if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) {

 Size = CmdBufNum[1];
 Number = Size*4;
 STMPE_State = 23;
#line 510 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 }
 STMPE_TimeoutCheck(22);
 break;

 case 23:
 if (I2C1_State == 0) {

 CmdBufNum = &BigBuffer;
 memset(CmdBufNum,0,8);
 PutFifo(CmdBufNum, 0x02 , 0xD7 ,Number);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 24;
 }
 STMPE_TimeoutCheck(23);
 break;

 case 24:
 if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0) && (Size > 1)) {
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 25;

 } else if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0) && (Size == 1)) {
 X = (CmdBufNum[1] << 4) | ((CmdBufNum[2] & 0xF0) >> 4);
 Y = ((CmdBufNum[2] & 0x0F) << 8) | CmdBufNum[3];
 Z = CmdBufNum[4];


 XNum = X / 8.6; YNum = Y / 14.8;

 Xcoord = (unsigned)XNum;
 Ycoord = (unsigned)YNum;
#line 550 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 if (ActiveFlag == 0) {
 ActiveFlag = 1;
 Process_TP_Press(Xcoord,Ycoord);
 Process_TP_Down(Xcoord,Ycoord);
 }
 set_timer(STMPETimer,5000);
 STMPE_State = 25;
 }
 STMPE_TimeoutCheck(24);
 break;


 case 25:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x4B ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 26;
 }
 STMPE_TimeoutCheck(25);
 break;

 case 26:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x40 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 27;
 }
 STMPE_TimeoutCheck(26);
 break;

 case 27:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x02;
 PutFifo(CmdBufNum, 0x01 , 0x0B ,1);
  {} ;
 set_timer(STMPETimer,50);
 STMPE_State = 34;
 }
 STMPE_TimeoutCheck(27);
 break;


 case 28:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 memset(CmdBufNum,0,8);
 PutFifo(CmdBufNum, 0x02 , 0x4C ,1);
  {} ;
 set_timer(STMPETimer,100);
 STMPE_State = 29;
 }
 STMPE_TimeoutCheck(28);
 break;

 case 29:
 if ((CmdBufNum[0] == 0xFF) && (I2C1_State == 0)) {
#line 619 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/STMPE610.c"
 set_timer(STMPETimer,5000);
 STMPE_State = 30;
 }
 STMPE_TimeoutCheck(29);
 break;

 case 30:
 if (ActiveFlag == 1)
 ActiveFlag = 0;

 set_timer(STMPETimer,5000);
 STMPE_State = 31;
 break;

 case 31:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x4B ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 32;
 }
 STMPE_TimeoutCheck(31);
 break;

 case 32:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x40 ,1);
  {} ;
 set_timer(STMPETimer,5000);
 STMPE_State = 33;
 }
 STMPE_TimeoutCheck(32);
 break;

 case 33:
 if (I2C1_State == 0) {
 CmdBufNum = GetCmdBuf();
 CmdBufNum[0] = 0x01;
 PutFifo(CmdBufNum, 0x01 , 0x0B ,1);
  {} ;
 set_timer(STMPETimer,50);
 STMPE_State = 34;
 }
 STMPE_TimeoutCheck(33);
 break;



 case 34:
 if (check_timer(STMPETimer) == 0) {
 set_timer(STMPETimer,5000);
 STMPE_State = 35;
 }
 break;

 case 35:
 if (I2C1_State == 0) {
  {} ;
 free_timer(STMPETimer);
 STMPE_State = 0;

 NVIC_IntEnable(IVT_INT_EXTI0);
 }
 STMPE_TimeoutCheck(35);
 break;
 }
}
