#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
#line 9 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/common.h"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
#line 19 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 11 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
int TimerFlag = 0;
unsigned int Msec = 0;
#line 22 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
 if (COUNTFLAG_bit) {
 irqhandler_timer();

 Msec += 1;
 if (Msec > 999) {
 Msec = 0;
 TimerFlag = 1;
 }
 }
}
#line 36 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
void Timer_Init() {
 init_timerpool();


 NVIC_SYSTICKRVR = 15000;
 NVIC_SYSTICKCVR = 0;
 ENABLE_SYSTICKCSR_bit = 1;
 TICKINT_bit = 1;
}
#line 48 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
void TimerCheck() {
 if (TimerFlag == 1) {
 TimerFlag = 0;


 }
}
#line 76 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
struct timers TimerPool[ 10 ];
#line 85 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
void init_timerpool(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 TimerPool[i].TimerField = 0;
 TimerPool[i].Free =  1 ;
 }
}
#line 100 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
unsigned short int get_timer(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 if (TimerPool[i].Free ==  1 ) {
 TimerPool[i].Free =  0 ;
 return i;
 }
 }


 UART6_PutQueue("TIMERS: No Timers, Resetting..\r\n");
 SystemReset();
 return (0);
}
#line 122 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
void free_timer(unsigned short int nbr) {
 if (nbr > ( 10 -1))
 return;

 TimerPool[nbr].Free =  1 ;
}
#line 136 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
void set_timer(unsigned short int nbr, unsigned long int tout) {
 if (nbr > ( 10 -1))
 return;

 if (TimerPool[nbr].Free ==  1 )
 return;

 TimerPool[nbr].TimerField = tout;
}
#line 152 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
unsigned long int check_timer(unsigned short int nbr) {
 return TimerPool[nbr].TimerField;
}
#line 162 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/Timers.c"
void irqhandler_timer(void) {
 unsigned short int i;

 for (i=0; i< 10 ; i++) {
 if (TimerPool[i].Free ==  0  && TimerPool[i].TimerField != 0)
 TimerPool[i].TimerField--;
 }
}
