#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
#line 11 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
#line 17 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
char* GetCmdBuf(void);
#line 12 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
char readbuff[64];
char writebuff[64];

USB_TxStruct USB_Queue;

unsigned long *Buffer = (unsigned long *)0x08000000;
#line 22 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
 USB_Interrupt_Proc();
}
#line 28 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
void USB_Init(void) {



 HID_Enable(&readbuff,&writebuff);
 USB_TxQueueInit();

}
#line 39 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
void USB_TxQueueInit(void) {
 USB_Queue.in = 0;
 USB_Queue.out = 0;
}
#line 47 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
void USB_PutQueue(char *msg) {
 USB_Queue.q[USB_Queue.in++] = msg;
 if (USB_Queue.in > ( 32 -1))
 USB_Queue.in = 0;
}
#line 59 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
void USB_CheckOut(void) {


 if (USB_Queue.in != USB_Queue.out) {

 if (HID_Write(USB_Queue.q[USB_Queue.out],64) != 0) {
 USB_Queue.out++;
 if (USB_Queue.out > ( 32 -1))
 USB_Queue.out = 0;
 }
 }
}
#line 76 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/USB_Driver.c"
void USB_CheckIn(void) {
 char *BufNum;


 unsigned int Data;

 if (HID_Read() != 0) {
 switch (readbuff[0]) {

 case 'a':
 BufNum = GetBuffer();
 sprintf(BufNum,"How now brown cow?\r\n");
 USB_PutQueue(BufNum);
 break;
 case 'b':
 Data = *Buffer;
 BufNum = GetBuffer();
 sprintf(BufNum,"Addr: %08LX  Data: %08LX\r\n",Buffer,Data);
 USB_PutQueue(BufNum);
 *Buffer++;
 break;
 case 'c':
 break;
 case 'd':
 break;
 case 'e':
 break;
 case 'f':
 break;
 case 'g':
 break;
 case 'h':
 break;
 case 'i':
 break;
 case 'j':
 break;
 case 'k':
 break;
 case 'l':
 break;
 case 'm':
 break;
 case 'n':
 break;
 case 'o':
 break;
 case 'p':
 break;
 case 'q':
 break;
 case 'r':
 break;
 case 's':
 break;
 case 't':
 break;
 case 'u':
 break;
 case 'v':
 break;
 case 'w':
 break;
 case 'x':
 break;
 case 'y':
 break;
 case 'z':
 SystemReset();
 break;



 default:
 USB_PutQueue("Unknown command\r\n");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",readbuff[0]);
 USB_PutQueue(BufNum);
 break;
 }
 }
}
