/**************************************************************************************************
  Common.h
  Some common definitions.
**************************************************************************************************/
#ifndef COMMON_H
#define COMMON_H


// Defines

#define FALSE 0
#define TRUE 1


#define DEBUG 0          // Set to 0 to prevent diagnostic messages on UART6

#if DEBUG == 1
#define DEBUGOUT(c) UART6_PutQueue(c)
#else
#define DEBUGOUT(c) {}
#endif


#define STMPEDEBUG 0     // Set to 0 to prevent STMPE610 diagnostic messages on UART6

#if STMPEDEBUG == 1
#define STMPEDEBUGOUT(c) UART6_PutQueue(c)
#else
#define STMPEDEBUGOUT(c) {}
#endif


#define USB_DEBUG 1      // Set to 0 to prevent diagnostic messages on USB

#if USB_DEBUG == 1
#define USB_DEBUGOUT(c) USB_PutQueue(c)
#else
#define USB_DEBUGOUT(c) {}
#endif


#define UseMikroE 0


#endif