#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
#line 19 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
#line 17 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
char* GetCmdBuf(void);
#pragma funcall UART6_Rx1, UART6_Rx2
#line 15 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
char RxIn;
char RxOut;
char RxQueue[ 256 ];

char RcvBuf[ 256 ];
char RcvBufPtr;


char TxIn;
char TxOut;
char *TxQueue[ 512 ];

char *XmtBuf;
char XmtBufPtr;



tPointerFcn UART6_RxFuncPtr = UART6_Rx1;
#line 40 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_Interrupt() iv IVT_INT_USART6 ics ICS_AUTO {
 char R_data;
 char T_data;


 if ((RXNE_USART6_SR_bit) ) {
 R_data = USART6_DR;
 RxQueue[RxIn++] = R_data;
 if (RxIn > ( 256 -1))
 RxIn = 0;
 }

 if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
 T_data = XmtBuf[XmtBufPtr++];
 if (T_data ==  0x00 ) {
 TXEIE_USART6_CR1_bit = 0;
 } else {
 USART6_DR = T_data;
 }
 }
}
#line 64 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_SetBaud(void) {
 UART6_Init_Advanced(9600,_UART_8_BIT_DATA,_UART_NOPARITY,_UART_ONE_STOPBIT,&_GPIO_MODULE_USART6_PC67);
 NVIC_IntEnable(IVT_INT_USART6);
}
#line 71 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_StartRx(void) {
 RXNEIE_USART6_CR1_bit = 1;
}
#line 77 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_StartTx(void) {
 TXEIE_USART6_CR1_bit = 1;
}
#line 88 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_Initialize(void) {
 UART6_RxQueueInit();
 UART6_TxQueueInit();

 UART6_SetBaud();
 UART6_StartRx();
}
#line 99 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_RxQueueInit(void) {
 RxIn = RxOut = 0;
 RcvBufPtr = 0;
}
#line 108 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
char UART6_GetChar(char *rxbyte) {
 if (RxIn != RxOut) {
 *rxbyte = RxQueue[RxOut++];
 if (RxOut > ( 256 -1))
 RxOut = 0;
 return 1;
 }else{
 return 0;
 }
}
#line 121 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx(void) {
 UART6_RxFuncPtr();
}
#line 128 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx1(void){
 char rxchar;

 if (UART6_GetChar(&rxchar)) {
 switch (rxchar) {
 case  0x00 :
 break;

 case '\r':
 break;

 case '\n':
 RcvBuf[RcvBufPtr++] = rxchar;
 RcvBuf[RcvBufPtr] = 0;
 RcvBufPtr = 0;
 UART6_RxFuncPtr = UART6_Rx2;
 break;

 default:
 if (RcvBufPtr < ( 256 -2))
 RcvBuf[RcvBufPtr++] = rxchar;
 break;
 }
 }
}
#line 157 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx2(void) {
 char *BufNum;

 switch (RcvBuf[0]) {

 case 'a':
 UART6_PutQueue("Command a received\r\n");
 break;





 case 'z':
 SystemReset();
 break;


 default:
 UART6_PutQueue("Unknown command: ");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
 UART6_PutQueue(BufNum);
 break;
 }
 UART6_RxFuncPtr = UART6_Rx1;
}
#line 191 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_TxQueueInit(void) {
 TxIn = TxOut = 0;
 XmtBufPtr = 0;
}
#line 199 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_PutQueue(char *msg) {
 TxQueue[TxIn++] = msg;
 if (TxIn > ( 512 -1))
 TxIn = 0;
}
#line 207 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_SendMsg(char *s) {
 XmtBuf = s;
 XmtBufPtr = 0;
 UART6_StartTx();
}
#line 216 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/UART6.c"
void UART6_CheckQueue(void) {
 if (TXEIE_USART6_CR1_bit == 0) {
 if (TxIn != TxOut) {
 UART6_SendMsg(TxQueue[TxOut++]);
 if (TxOut > ( 512 -1))
 TxOut = 0;
 }
 }
}
